// CosTable.cpp: implementation of the CCosTable class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "flow3d.h"
#include "CosTable.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCosTable::CCosTable(float start, float end, int width)
{
    const float pi = (float)(4.0f * atan(1.0f));

    m_CosTable = new float[width];
       
    for (int i=0; i < width; i++)
        m_CosTable[i] = (float)cos((start + (i* ((end - start) / width))) * 
						 pi / 180.0f);
}

CCosTable::CCosTable()
{
	m_CosTable = NULL;
}

CCosTable::~CCosTable()
{
	if(m_CosTable != NULL)
		delete m_CosTable;
}

float CCosTable::GetCos(int index)
{
	return m_CosTable[index];
}
