// EulerOp.cpp: implementation of the CEulerOp class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Flow3D.h"
#include "EulerOp.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEulerOp::CEulerOp()
{
	m_VectorField = NULL;
	m_Interpolator = NULL;
	m_Dt = 0;
	
}

CEulerOp::CEulerOp(CVectorField *vectorField,CInterpolator *interpolator,float dt)
{
	m_VectorField = vectorField;
	m_Interpolator = interpolator;
	m_Dt = dt;
}

CEulerOp::~CEulerOp()
{
}

CSamplePoint *CEulerOp::ComputeNext(CSamplePoint *lastPoint)
{
	m_NextPos.m_XPos = lastPoint->GetXPos() + lastPoint->GetXVec()*m_Dt;
	m_NextPos.m_YPos = lastPoint->GetYPos() + lastPoint->GetYVec()*m_Dt;
	m_NextPos.m_ZPos = lastPoint->GetZPos() + lastPoint->GetZVec()*m_Dt;
	
	return m_Interpolator->Interpolate(m_NextPos,m_VectorField->GetSamplePoints(m_NextPos));
}