// EulerOp.h: interface for the CEulerOp class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EULEROP_H__85B4998B_3911_4CA8_8B96_19E9912544BF__INCLUDED_)
#define AFX_EULEROP_H__85B4998B_3911_4CA8_8B96_19E9912544BF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Integrator.h"

//!  A class that implements the Euler-operator.
/*!  The Euler-operator is a simple integration-method using the formula
	 s1 = s0 + v0*dt.
*/
class CEulerOp : public CIntegrator  
{
public:
	CEulerOp();
	CEulerOp::CEulerOp(CVectorField *vectorField, CInterpolator *interpolator,float dt);

	virtual ~CEulerOp();
	//! Makes one euler-step and returns pointer to new samplepoint.
	virtual CSamplePoint *ComputeNext(CSamplePoint *lastPoint);
private:
	CPoint3D m_NextPos;
};

#endif // !defined(AFX_EULEROP_H__85B4998B_3911_4CA8_8B96_19E9912544BF__INCLUDED_)
