// HistoDataStream.h: interface for the CHistoDataStream class.
//
//////////////////////////////////////////////////////////////////////
#include "StreamlinePiece.h"

#if !defined(AFX_HISTODATASTREAM_H__34F35A48_666B_4EBE_9A5D_FC03C40AB573__INCLUDED_)
#define AFX_HISTODATASTREAM_H__34F35A48_666B_4EBE_9A5D_FC03C40AB573__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//! Class representing a data stream for a histogram.
class CHistoDataStream
{
public:
	//! Returns type of histogram data.
	int GetHistoType();
	//! Returns flag which indicates if streamline piece data is valid.
	bool IsValid(CStreamlinePiece *piece);
	//! Sets histogram type.
	void SetHistoType(int type);
	//! Returns scalar values type.
	int GetScalarType();
	//! Sets scalar values type.
	void SetScalarType(int scalarType);
	//! Returns scalar value of specified type from piece.
	float GetScalar(CStreamlinePiece *piece);
	//! Get first scalar in stream.
	bool GetFirst(float &scalar);

	//! Sets list position to first position.
	void Reset();

	//! Returns pointer to pieces list.
	CObList * GetPiecesList();
	//! Sets pointer to pieces list.
	void SetPiecesList(CObList *list);

	//! Constructor which sets pieces lists and histogram type.
	HistoDataStream(CObList *piecesLists, int histoType);

	//! Returns true if a scalar could be found, else false.
	bool GetNext(float &scalar);
	
	//! Standard constructor.
	CHistoDataStream();

	virtual ~CHistoDataStream();

private:
	CObList *m_PiecesList;
	POSITION m_CurrentPos;
	int m_ScalarType;
	int m_HistoType;
};

#endif // !defined(AFX_HISTODATASTREAM_H__34F35A48_666B_4EBE_9A5D_FC03C40AB573__INCLUDED_)
