// Integrator.cpp: implementation of the CIntegrator class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Flow3D.h"
#include "Integrator.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CIntegrator::CIntegrator()
{
	m_VectorField = NULL;
	m_Interpolator = NULL;
	m_Dt = 0;
}

CIntegrator::CIntegrator(CVectorField *vectorField,CInterpolator *interpolator, float dt)
{
	m_VectorField = vectorField;
	m_Interpolator = interpolator;
	m_Dt = dt;
}

CIntegrator::~CIntegrator()
{
}

void CIntegrator::SetInterpolator(CInterpolator *interpolator)
{
	m_Interpolator = interpolator;
}

void CIntegrator::SetDt(float dt)
{
	m_Dt = dt;
}

CSamplePoint *CIntegrator::ComputeLast(CSamplePoint *nextPoint)
{
	SetDt(-m_Dt);
	CSamplePoint *result = ComputeNext(nextPoint);
	SetDt(-m_Dt);	

	return result;
}