// Interpolator.h: interface for the CInterpolator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INTERPOLATOR_H__5A2C4D5B_035C_4A4D_9384_CB800484BDA6__INCLUDED_)
#define AFX_INTERPOLATOR_H__5A2C4D5B_035C_4A4D_9384_CB800484BDA6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SamplePoint.h"
#include "Defines.h"

//! A class that is the base class for all interpolators.
/*!	Interpolators compute new samplePoints using a position value
	and the surrounding samplepoints.
*/
class CInterpolator  
{
public:
	CInterpolator();
	//! Interpolates new samplepoint on specified position.
	/*!	The interpolator computes new samplepoint on specified position, using
		the surrounding samplepoints stored in the vector neighbours.
	*/
	CSamplePoint *Interpolate(CPoint3D &position,CSamplePoint ** neighbour);
	virtual void Interpolate(CSamplePoint *sp, CPoint3D &position,CSamplePoint ** neighbour) = 0;
	virtual ~CInterpolator();
};

#endif // !defined(AFX_INTERPOLATOR_H__5A2C4D5B_035C_4A4D_9384_CB800484BDA6__INCLUDED_)
