// MyAddInfoDialog.cpp : implementation file
//

#include "stdafx.h"
#include "flow3d.h"
#include "MyAddInfoDialog.h"
#include "SamplePoint.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyAddInfoDialog dialog


MyAddInfoDialog::MyAddInfoDialog(CWnd* pParent /*=NULL*/)
	: CDialog(MyAddInfoDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(MyAddInfoDialog)
	m_AddInfoType = -1;
	m_AddInfoRepr = -1;
	//}}AFX_DATA_INIT
}


void MyAddInfoDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MyAddInfoDialog)
	DDX_CBIndex(pDX, IDC_ADDINFOTYPECOMBO, m_AddInfoType);
	DDX_Radio(pDX, IDC_CONTTRANSFRADIO, m_AddInfoRepr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MyAddInfoDialog, CDialog)
	//{{AFX_MSG_MAP(MyAddInfoDialog)
	ON_WM_PAINT()
	ON_CBN_SELCHANGE(IDC_ADDINFOTYPECOMBO, OnSelChangeAddInfoTypeCombo)
	ON_BN_CLICKED(IDC_EDITREGIONSBUTTON, OnEditRegionsButton)
	ON_BN_CLICKED(IDC_CONTTRANSFBUTTON, OnEditContTransfButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyAddInfoDialog message handlers

BOOL MyAddInfoDialog::OnInitDialog() 
{
	// TODO: Add extra initialization here

	CComboBox *pCombo = (CComboBox *)GetDlgItem( IDC_ADDINFOTYPECOMBO );

	pCombo->InsertString(-1,DEF_VELOCITY_STR);
	pCombo->InsertString(-1,DEF_ORIENT_X_STR);
	pCombo->InsertString(-1,DEF_ORIENT_Y_STR);
	pCombo->InsertString(-1,DEF_ORIENT_Z_STR);
	pCombo->InsertString(-1,DEF_POS_X_STR);
	pCombo->InsertString(-1,DEF_POS_Y_STR);
	pCombo->InsertString(-1,DEF_POS_Z_STR);
	pCombo->InsertString(-1,DEF_DIF_ORIENT_STR);
	pCombo->InsertString(-1,DEF_DIF_VLEN_STR);

	for(int i=0;i<CSamplePoint::GetAdditionalSize();i++)
	{
		char str[20];
		sprintf(str,"%s %d",DEF_ADDINFO_STR, i);
		
		pCombo->InsertString(-1, str);
	}

	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void MyAddInfoDialog::OnPaint() 
{
//	OnPaint();
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	CFrameWnd * pColorImage = (CFrameWnd *)GetDlgItem( IDC_CONT_COLORIMG1 );
	CFrameWnd * pContOpImage = (CFrameWnd *)GetDlgItem( IDC_CONT_OPACITYIMG1 );
	
	CFrameWnd * pAmbientImage = (CFrameWnd *)GetDlgItem( IDC_REGIONSIMG_AMB );
	CFrameWnd * pDiffuseImage = (CFrameWnd *)GetDlgItem( IDC_REGIONSIMG_DIF );
	CFrameWnd * pSpecularImage = (CFrameWnd *)GetDlgItem( IDC_REGIONSIMG_SPEC );
	CFrameWnd * pRegOpImage = (CFrameWnd *)GetDlgItem( IDC_REGIONSIMG_OPACITY1 );
	
	CComboBox * pCombo = (CComboBox *)GetDlgItem( IDC_ADDINFOTYPECOMBO );

	CRect colorRect;
	CRect ambientRect;
	CRect specularRect;
	CRect diffuseRect;
	CRect regOpRect;
	
	pColorImage->GetWindowRect(colorRect);
	pAmbientImage->GetWindowRect(ambientRect);
	pDiffuseImage->GetWindowRect(diffuseRect);
	pSpecularImage->GetWindowRect(specularRect);
	pRegOpImage->GetWindowRect(regOpRect);

	CPaintDC colorDC(pColorImage); // device context for painting
	CPaintDC contOpDC(pContOpImage);
	CPaintDC ambientDC(pAmbientImage); 
	CPaintDC diffuseDC(pDiffuseImage); 
	CPaintDC specularDC(pSpecularImage); 
	CPaintDC regOpDC(pRegOpImage);

	pColorImage->GetWindowRect(colorRect);
	
	HDC hDC = colorDC.GetSafeHdc();
	HDC hContOpDC = contOpDC.GetSafeHdc();

	float middlePos = m_ContTransfDialog.GetInterPos();

	const int size = DEF_CONTTRANSFVALUES_NUM + 1;
	int colIndex = size - 1;

	GLubyte color[size][4];
	
	for(int i = 0; i < colIndex; i++)
		m_ContTransfDialog.GetRGBA(i,color[i]);

	// Draw continous color-code transfer function.
	for(i=0;i<colorRect.Width();i++)
	{
		MyHisto1Dialog::
			MapValue2Color_3(color[colIndex],color[0],color[1],color[2],
							(float)i,0.0f,middlePos,(float)colorRect.Width());

		for(int j=0;j<colorRect.Height();j++)
		{
			SetPixel(hDC,i,j,color[colIndex][0]+color[colIndex][1]*256+
					 color[colIndex][2]*256*256);
			SetPixel(hContOpDC,i,j,color[colIndex][3]+color[colIndex][3]*256+
					 color[colIndex][3]*256*256);
		}
	}

	HDC hAmbientDC = ambientDC.GetSafeHdc();
	HDC hDiffuseDC = diffuseDC.GetSafeHdc();
	HDC hSpecularDC = specularDC.GetSafeHdc();
	HDC hRegOpDC = regOpDC.GetSafeHdc();

	CStreamlineMaterial material;

	RegProp prop[DEF_REGIONS_NUM];

	for(i=0;i<DEF_REGIONS_NUM;i++)
		prop[i].pos = m_RegionsDialog.GetRegionPos(i);

	// Draw regions material transfer function.
	for(i=0;i<ambientRect.Width();i++)
	{
		int index = 
			MyEditRegionsDialog::MapValue2PropNr(prop, DEF_REGIONS_NUM, (float)i, 
												 0.0f, (float)ambientRect.Width());

		if(index < DEF_REGIONS_NUM)
		{
			material = m_RegionsDialog.GetMaterial(index);
			
		}
		else
		{
			material = m_RegionsDialog.m_DefaultProp.material;
		}
		for(int j=0;j<ambientRect.Height();j++)
		{
			SetPixel(hAmbientDC,i,j,material.m_AmbientRGB[0]+
									material.m_AmbientRGB[1]*256+
									material.m_AmbientRGB[2]*256*256);
		}
		for(j=0;j<diffuseRect.Height();j++)
		{
			SetPixel(hDiffuseDC,i,j,material.m_DiffuseRGB[0]+
									material.m_DiffuseRGB[1]*256+
									material.m_DiffuseRGB[2]*256*256);
		}
		for(j=0;j<specularRect.Height();j++)
		{
			SetPixel(hSpecularDC,i,j,material.m_SpecularRGB[0]+
									 material.m_SpecularRGB[1]*256+
									 material.m_SpecularRGB[2]*256*256);
		}
		for(j=0;j<regOpRect.Height();j++)
		{
			SetPixel(hRegOpDC,i,j,material.m_Opacity+
								  material.m_Opacity*256+
								  material.m_Opacity*256*256);
		}
	}

	// Do not call CDialog::OnPaint() for painting messages
}

void MyAddInfoDialog::OnSelChangeAddInfoTypeCombo() 
{
	// TODO: Add your control notification handler code here
	RedrawWindow();
}

int MyAddInfoDialog::GetAddInfoType()
{
	return m_AddInfoType;
}

void MyAddInfoDialog::SetAddInfoType(int addInfoType)
{
	m_AddInfoType = addInfoType;
}

void MyAddInfoDialog::OnEditRegionsButton() 
{
	// TODO: Add your control notification handler code here
	CHistoData *histoData = m_RegionsDialog.m_Histo1Dialog.m_HistoData;

	CComboBox *pCombo = (CComboBox *)GetDlgItem( IDC_ADDINFOTYPECOMBO );

	int scalarType = pCombo->GetCurSel();
	histoData->GetDataStream()->SetScalarType(scalarType);
	histoData->SetMinMaxScalar(m_MinScalars[scalarType],m_MaxScalars[scalarType]);

	histoData->CalcDistribution();

	m_RegionsDialog.DoModal();
	this->RedrawWindow();
}

void MyAddInfoDialog::SetHistoData(CHistoData *histoData)
{
	m_RegionsDialog.m_Histo1Dialog.SetHistoData(histoData);
	m_ContTransfDialog.m_Histo1Dialog.SetHistoData(histoData);
}

void MyAddInfoDialog::OnEditContTransfButton() 
{
	// TODO: Add your control notification handler code here
	CHistoData *histoData = m_ContTransfDialog.m_Histo1Dialog.m_HistoData;

	CComboBox *pCombo = (CComboBox *)GetDlgItem( IDC_ADDINFOTYPECOMBO );

	int scalarType = pCombo->GetCurSel();
	histoData->GetDataStream()->SetScalarType(scalarType);
	histoData->SetMinMaxScalar(m_MinScalars[scalarType],m_MaxScalars[scalarType]);

	histoData->CalcDistribution();

	m_ContTransfDialog.DoModal();
	RedrawWindow();
}

void MyAddInfoDialog::SetAddInfoRepr(int repr)
{
	m_AddInfoRepr= repr;
}

int MyAddInfoDialog::GetAddInfoRepr()
{
	return m_AddInfoRepr;
}
