#if !defined(AFX_MYADDINFODIALOG_H__6D41BFA3_994F_40FB_A307_19572DFADF8B__INCLUDED_)
#define AFX_MYADDINFODIALOG_H__6D41BFA3_994F_40FB_A307_19572DFADF8B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyAddInfoDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyAddInfoDialog dialog
#include "gl\gl.h"
#include "SamplePoint.h"
#include "MyEditRegionsDialog.h"
#include "Defines.h"
#include "MyOpacityDialog.h"	// Added by ClassView
#include "MyContTransfDialog.h"

//! Dialog class for specifying additional info representation.
class MyAddInfoDialog : public CDialog
{
// Construction
public:
	//! Returns add. info representation.
	int GetAddInfoRepr();
	//! Sets additional info representation.
	void SetAddInfoRepr(int repr);
	//! Sets histogram data.
	void SetHistoData(CHistoData *histoData);
	//! Returns additional info type.
	int GetAddInfoType();
	//! Sets add. info representation.
	void SetAddInfoType(int addInfoType);
	MyAddInfoDialog(CWnd* pParent = NULL);   // standard constructor

	//! Array of minimal scalar values.
	float *m_MinScalars;
	//! Array of maximal scalar values.
	float *m_MaxScalars;

	//! Continuous transfer properties dialog.
	MyContTransfDialog m_ContTransfDialog;
	//! Region properties dialog.
	MyEditRegionsDialog m_RegionsDialog;

// Dialog Data
	//{{AFX_DATA(MyAddInfoDialog)
	enum { IDD = IDD_ADDINFODIALOG };
	int		m_AddInfoType;
	int		m_AddInfoRepr;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyAddInfoDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyAddInfoDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg void OnSelChangeAddInfoTypeCombo();
	afx_msg void OnEditRegionsButton();
	afx_msg void OnEditContTransfButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYADDINFODIALOG_H__6D41BFA3_994F_40FB_A307_19572DFADF8B__INCLUDED_)
