#if !defined(AFX_MYALGOOPTDIALOG_H__727DC1C2_4B18_445B_A1A6_BCE4C9DB647C__INCLUDED_)
#define AFX_MYALGOOPTDIALOG_H__727DC1C2_4B18_445B_A1A6_BCE4C9DB647C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyAlgoOptDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyAlgoOptDialog dialog

#include "EulerOp.h"
#include "RungeKutta2Op.h"
#include "RungeKutta4Op.h"

#include "NearestNeighbour.h"
#include "Trilinear.h"
#include "TrilinearVLength.h"
#include "RectTrilinear.h"
#include "RectTrilinVLength.h"
#include "Defines.h"

//! Dialog class for specifying ESS-algorithm parameters.
class MyAlgoOptDialog : public CDialog
{
// Construction
public:
	//! Returns integrator type.
	int GetIntegratorType();
	//! Returns interpolator type.
	int GetInterpolatorType();
	//! Initialise dialog members.
	void InitAlgoOptDlg(float dSepPerc,float dTest,float dT, 
						int caPerSP,int maxIterations,int integrator,
						int interpolator);

	//! Creates interpolator according to index value.
	static CInterpolator * CreateInterpolator(int interpolatorType);
	//! Creates integrator according to index value.
	static CIntegrator * CreateIntegrator(int integratorType,CVectorField *vectorField,
										  float dt, CInterpolator *interpolator);

	//! Returns candidates per samplepoint.
	int GetCaPerSP();
	//! Returns maximal iteration depth.
	int GetMaxIterations();
	//! Returns dt(= step size of integrator.
	float GetDt();
	//! Returns test distance.
	float GetDTest();
	//! Returns separating distance.
	float GetDSepPerc();
	MyAlgoOptDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(MyAlgoOptDialog)
	enum { IDD = IDD_ALGOPTDIALOG };
	int		m_IntegratorType;
	int		m_InterpolatorType;
	float	m_DSepPerc;
	float	m_DT;
	float	m_DTest;
	int		m_MaxIterations;
	int		m_CaPerSP;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyAlgoOptDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyAlgoOptDialog)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYALGOOPTDIALOG_H__727DC1C2_4B18_445B_A1A6_BCE4C9DB647C__INCLUDED_)
