// MyBlockDialog.cpp : implementation file
//

#include "stdafx.h"
#include "flow3d.h"
#include "MyBlockDialog.h"
#include "Defines.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyBlockDialog dialog

GLubyte MyBlockDialog::blTex[DEF_BLTEX_HEIGHT][DEF_BLTEX_WIDTH][4];

MyBlockDialog::MyBlockDialog(CWnd* pParent /*=NULL*/)
	: CDialog(MyBlockDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(MyBlockDialog)
	m_ZOffs = 0;
	m_IsTex = FALSE;
	//}}AFX_DATA_INIT
}


void MyBlockDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MyBlockDialog)
	DDX_Slider(pDX, IDC_ZOFFSSLIDER, m_ZOffs);
	DDX_Check(pDX, IDC_ISTEX_CHECK, m_IsTex);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MyBlockDialog, CDialog)
	//{{AFX_MSG_MAP(MyBlockDialog)
	ON_BN_CLICKED(IDC_MATERIALBUTTON, OnMaterialButton)
	ON_BN_CLICKED(IDC_LOADTEX_BUTTON, OnLoadTexButton)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyBlockDialog message handlers

float MyBlockDialog::GetZOffs()
{
	return (float)m_ZOffs/DEF_BLOCK_ZOFFSSLIDER_FACTOR;
}

void MyBlockDialog::SetZOffs(float zOffs)
{
	m_ZOffs = (int)(zOffs * DEF_BLOCK_ZOFFSSLIDER_FACTOR);
}

void MyBlockDialog::OnMaterialButton() 
{
	// TODO: Add your control notification handler code here
	m_MaterialDialog.DoModal();
}

BOOL MyBlockDialog::OnInitDialog() 
{
	CSliderCtrl * pZOffsSlider = (CSliderCtrl*)GetDlgItem( IDC_ZOFFSSLIDER );
	pZOffsSlider->SetRange(DEF_BLOCK_ZOFFSSLIDER_MIN, DEF_BLOCK_ZOFFSSLIDER_MAX);

	
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void MyBlockDialog::OnLoadTexButton() 
{
	// TODO: Add your control notification handler code here
	CFileDialog fileDialog(TRUE);
	
	if(fileDialog.DoModal()==IDOK)
	{
		CString  filename = fileDialog.GetPathName();
		ReadBlTex(filename);
		RedrawWindow();
	}
}

void MyBlockDialog::ReadBlTex(CString filename)
{
	// Read 54 byte header.
	char header[DEF_BMP_HEADER_SIZE];
	
	try
	{
		CFile file(filename, CFile::modeRead);
		file.Read(header,DEF_BMP_HEADER_SIZE);

		// Help variables.
		int hi=0;
		int hj=0;

		for(int i=0;i<DEF_BLTEX_HEIGHT;i++)
			for(int j=0;j<DEF_BLTEX_WIDTH;j++)
			{
				hi = DEF_BLTEX_HEIGHT - 1 - i;
				hj = DEF_BLTEX_WIDTH - 1 - j;

				file.Read(&blTex[hi][hj][2],1);
				file.Read(&blTex[hi][hj][1],1);
				file.Read(&blTex[hi][hj][0],1);
				blTex[i][j][3] = DEF_OPACITY_MAX;
			}

		file.Close();
	}
	catch(CFileException *e)
	{
	}
}

void MyBlockDialog::SetIsTex(bool isTex)
{
	m_IsTex = isTex;
}

bool MyBlockDialog::GetIsTex()
{
	return (m_IsTex == TRUE);
}

void MyBlockDialog::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CFrameWnd * pTexImg = (CFrameWnd *)GetDlgItem( IDC_TEX_IMG );

	CRect rect;
	pTexImg->GetWindowRect(rect);
	
	int height = min(rect.Height(),DEF_BLTEX_HEIGHT);
	int width = min(rect.Width(),DEF_BLTEX_WIDTH);

	CPaintDC texDC(pTexImg); 
	
	HDC hTexDC = texDC.GetSafeHdc();
	
	for(int i=0;i<width;i++)
		for(int j=0;j<height;j++)
			SetPixel(hTexDC,j,i,blTex[i][j][0]+
					 (blTex[i][j][1]<<8)+(blTex[i][j][2]<<16));
}

void MyBlockDialog::InitBlockTex()
{
	for(int i=0;i<DEF_BLTEX_HEIGHT;i++)
		for(int j=0;j<DEF_BLTEX_WIDTH;j++)
		{
			for(int k=0;k<3;k++)
				blTex[i][j][k] = DEF_COLOR_MAX;
			blTex[i][j][3] = DEF_OPACITY_MAX;
		}
}
