#if !defined(AFX_MYCONTTRANSFDIALOG_H__028ED565_607A_46ED_B81D_A24A5C94890B__INCLUDED_)
#define AFX_MYCONTTRANSFDIALOG_H__028ED565_607A_46ED_B81D_A24A5C94890B__INCLUDED_

#include "gl/gl.h"
#include "MyContTransfPropDialog.h"
#include "Defines.h"
#include "MyHisto1Dialog.h"	// Added by ClassView

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyContTransfDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyContTransfDialog dialog

//! Dialog specifying continuous transfer function properties.
class MyContTransfDialog : public CDialog
{
// Construction
public:
	//! Histogram dialog.
	MyHisto1Dialog m_Histo1Dialog;

	//! Continuous streamline properties in min, inter and max-position.
	MyContTransfPropDialog m_PropDialog[DEF_CONTTRANSFVALUES_NUM];

	//! Returns continuous streamline properties in min,inter or max-position.
	void GetContProp(int index, ContTransfProp &prop);
	//! Sets continuous streamline properties in min,inter or max-position.
	void SetContProp(int index, ContTransfProp &prop);
	//! Sets continuous opacity in min,inter or max-position.
	void SetOpacity(int index, GLubyte opacity);
	//! Returns continuous opacity in min,inter or max-position. 
	GLubyte GetOpacity(int index);

	//! Returns continuous streamline resolution in min,inter or max-position. 
	int GetRes(int index);
	//! Sets continuous streamline resolution in min,inter or max-position. 
	void SetRes(int index, int res);

	//! Maps scalar value to property of transfer function with two defining points.
	static void MapValue2Prop_3(ContTransfProp &result, float value, ContTransfProp *props, 
							    float *pos);
	
	//! Maps scalar value to property of transfer function with two defining points.
	static void MapValue2Prop(ContTransfProp &result, float value, ContTransfProp *props, 
							  float *pos);

	//! Returns continuous streamline color in min, inter or max-position.
	void GetRGBA(int index, GLubyte *rgba);
	//! Sets continuous streamline color in min, inter or max-position.
	void SetRGBA(int index, GLubyte *rgba);

	//! Sets intermediate properties position.
	void SetInterPos(float interPos);
	//! Returns intermediate properties position.
	float GetInterPos();
	//! Standard constructor.
	MyContTransfDialog(CWnd* pParent = NULL);
// Dialog Data
	//{{AFX_DATA(MyContTransfDialog)
	enum { IDD = IDD_CONTTRANSFDIALOG };
	int		m_MiddleValue;
	int		m_InterPos;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyContTransfDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyContTransfDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg void OnReleasedCaptureInterPosSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnMinPosButton();
	afx_msg void OnInterPosButton();
	afx_msg void OnMaxPosButton();
	afx_msg void OnHistoButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYCONTTRANSFDIALOG_H__028ED565_607A_46ED_B81D_A24A5C94890B__INCLUDED_)
