// MyContTransfPropDialog.cpp : implementation file
//

#include "stdafx.h"
#include "flow3d.h"
#include "MyContTransfPropDialog.h"
#include "Defines.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyContTransfPropDialog dialog


MyContTransfPropDialog::MyContTransfPropDialog(CWnd* pParent /*=NULL*/)
	: CDialog(MyContTransfPropDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(MyContTransfPropDialog)
	m_LineWidth = 0;
	m_Res = 0;
	m_Opacity = 0;
	//}}AFX_DATA_INIT
}


void MyContTransfPropDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MyContTransfPropDialog)
	DDX_Slider(pDX, IDC_LINEWIDTHSLIDER, m_LineWidth);
	DDX_Slider(pDX, IDC_RESSLIDER, m_Res);
	DDX_Slider(pDX, IDC_OPACITYSLIDER, m_Opacity);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MyContTransfPropDialog, CDialog)
	//{{AFX_MSG_MAP(MyContTransfPropDialog)
	ON_BN_CLICKED(IDC_COLORBUTTON, OnColorButton)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyContTransfPropDialog message handlers

BOOL MyContTransfPropDialog::OnInitDialog() 
{
	CSliderCtrl *pResSlider = (CSliderCtrl *)GetDlgItem( IDC_RESSLIDER);
	CSliderCtrl *pLineWidthSlider = (CSliderCtrl *)GetDlgItem( IDC_LINEWIDTHSLIDER);
	CSliderCtrl *pOpacitySlider = (CSliderCtrl *)GetDlgItem( IDC_OPACITYSLIDER);

	pResSlider->SetRange(DEF_PERCENTSLIDER_MIN,DEF_PERCENTSLIDER_MAX);
	pLineWidthSlider->SetRange(DEF_LINEWIDTHSLIDER_MIN,DEF_LINEWIDTHSLIDER_MAX);
	pOpacitySlider->SetRange(DEF_OPACITYSLIDER_MIN,DEF_OPACITYSLIDER_MAX);

	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void MyContTransfPropDialog::OnColorButton() 
{
	// TODO: Add your control notification handler code here
	m_ColorDialog.DoModal();
	RedrawWindow();
}

float MyContTransfPropDialog::GetLineWidth()
{
	return (float)m_LineWidth / (float)DEF_LINEWIDTHSLIDER_FACTOR;
}

void MyContTransfPropDialog::SetLineWidth(float lineWidth)
{
	m_LineWidth = (int)(lineWidth * DEF_LINEWIDTHSLIDER_FACTOR);
}

void MyContTransfPropDialog::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CFrameWnd * pImage = (CFrameWnd *)GetDlgItem( IDC_COLORIMG );

	CRect rect;

	pImage->GetWindowRect(rect);
	CPaintDC myDC(pImage);
	HDC hDC = myDC.GetSafeHdc();

	GLubyte rgb[3];

	GetRgb(rgb);

	for(int i=0;i<rect.Width();i++)
		for(int j=0;j<rect.Height();j++)
			SetPixel(hDC,i,j,rgb[0]+(rgb[1]<<8)+(rgb[2]<<16));

	// Do not call CDialog::OnPaint() for painting messages
}

void MyContTransfPropDialog::GetRgb(GLubyte *rgb)
{
	COLORREF c = m_ColorDialog.GetColor();

	rgb[0] = (GLubyte)(c & 255);
	rgb[1] = (GLubyte)((c>>8) & 255);
	rgb[2] = (GLubyte)((c>>16) & 255);
}
