#if !defined(AFX_MyContTransfPropDialog_H__7DDCF36D_4059_4D9A_86A1_FB8C1D9F8D4F__INCLUDED_)
#define AFX_MyContTransfPropDialog_H__7DDCF36D_4059_4D9A_86A1_FB8C1D9F8D4F__INCLUDED_

#include "gl/gl.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyContTransfPropDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyContTransfPropDialog dialog

//! Structure which holds continuous transfer properties.
struct ContTransfProp
{ 
	//! Streamline color.
	GLubyte rgba[4];
	//! Streamline linewidth.
	float lineWidth;
	//! Streamline resolution.
	int res;
};

//! Dialog for setting continuous transfer porperty on certain position.
class MyContTransfPropDialog : public CDialog
{
// Construction
public:
	//! Returns rgb.
	void GetRgb(GLubyte *rgb);
	//! Sets linewidth.
	void SetLineWidth(float lineWidth);
	//! Returns line width.
	float GetLineWidth();
	//! Color dialog for setting color-property.
	CColorDialog m_ColorDialog;
	MyContTransfPropDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(MyContTransfPropDialog)
	enum { IDD = IDD_CONTTRANSF_PROP_DIALOG };
	int		m_LineWidth;
	int		m_Res;
	int		m_Opacity;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyContTransfPropDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyContTransfPropDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnColorButton();
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MyContTransfPropDialog_H__7DDCF36D_4059_4D9A_86A1_FB8C1D9F8D4F__INCLUDED_)
