// MyCube.h: interface for the MyCube class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYCUBE_H__5F1F9736_8D0F_4520_AD22_84DEA43CC2CD__INCLUDED_)
#define AFX_MYCUBE_H__5F1F9736_8D0F_4520_AD22_84DEA43CC2CD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyObject.h"
#include "Point3D.h"	// Added by ClassView

//! Class representing a cube.
class MyCube : public MyObject
{
public:
	virtual void Init(MyObject *obj);
	//! Returns point with maximal xyz-coordinates.
	CPoint3D GetMaxPoint();
	//! Returns point with minimal xyz-coordinates.
	CPoint3D GetMinPoint();
	MyCube(CPoint3D position, float size, float lineWidth,GLubyte *rgba);
	//! Returns size of cube.
	float GetSize();
	//! Sets size of cube.
	void SetSize(float size);
	virtual void SetPosition(CPoint3D position);

	virtual void Draw();
	virtual bool IsInside(CPoint3D pos);
	MyCube();
	virtual ~MyCube();
protected:
	void UpdateMinPoint();
	void UpdateMaxPoint();

	CPoint3D m_MinPoint;
	CPoint3D m_MaxPoint;

	float m_Size;
};

#endif // !defined(AFX_MYCUBE_H__5F1F9736_8D0F_4520_AD22_84DEA43CC2CD__INCLUDED_)
