// MyDepthCodingDialog.cpp : implementation file
//

#include "stdafx.h"
#include "flow3d.h"
#include "MyDepthCodingDialog.h"
#include "Defines.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyDepthCodingDialog dialog


MyDepthCodingDialog::MyDepthCodingDialog(CWnd* pParent /*=NULL*/)
	: CDialog(MyDepthCodingDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(MyDepthCodingDialog)
	m_DepthType = -1;
	m_Intensity = 0;
	//}}AFX_DATA_INIT
}


void MyDepthCodingDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MyDepthCodingDialog)
	DDX_Radio(pDX, IDC_DEPTHCUINGRADIO, m_DepthType);
	DDX_Slider(pDX, IDC_INTENSITYSLIDER, m_Intensity);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MyDepthCodingDialog, CDialog)
	//{{AFX_MSG_MAP(MyDepthCodingDialog)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_COLORBUTTON, OnColorButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyDepthCodingDialog message handlers

int MyDepthCodingDialog::GetDepthType()
{
	return m_DepthType;
}

void MyDepthCodingDialog::SetDepthType(int depthType)
{
	m_DepthType = depthType;
}

void MyDepthCodingDialog::SetColor(GLubyte *color)
{
	m_ColorDialog.m_cc.rgbResult = 
		color[0] + color[1]*256 + color[2]*256*256;
}

void MyDepthCodingDialog::GetColor(GLubyte *color)
{
	COLORREF c = m_ColorDialog.GetColor();
	color[0] = (GLubyte)(c & 255);
	color[1] = (GLubyte)((c>>8) & 255);
	color[2] = (GLubyte)((c>>16) & 255);
}

void MyDepthCodingDialog::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CFrameWnd * pImage = (CFrameWnd *)GetDlgItem( IDC_COLORIMG );

	CRect rect;

	pImage->GetWindowRect(rect);
	CPaintDC myDC(pImage);
	HDC hDC = myDC.GetSafeHdc();

	GLubyte rgb[3];

	GetColor(rgb);

	for(int i=0;i<rect.Width();i++)
		for(int j=0;j<rect.Height();j++)
			SetPixel(hDC,i,j,rgb[0]+(rgb[1]<<8)+(rgb[2]<<16));
	// Do not call CDialog::OnPaint() for painting messages
}

void MyDepthCodingDialog::OnColorButton() 
{
	// TODO: Add your control notification handler code here
	m_ColorDialog.DoModal();
	RedrawWindow();
}

void MyDepthCodingDialog::SetIntensity(int intensity)
{
	m_Intensity = intensity;
}

int MyDepthCodingDialog::GetIntensity()
{
	return m_Intensity;
}

BOOL MyDepthCodingDialog::OnInitDialog() 
{
	CSliderCtrl * pIntensSlider = (CSliderCtrl*)GetDlgItem( IDC_INTENSITYSLIDER );

	pIntensSlider->SetRange(DEF_INTENSITYSLIDER_MIN, DEF_INTENSITYSLIDER_MAX);
	pIntensSlider->SetTic(DEF_INTENSITYSLIDER_MAX/2);

	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
