#if !defined(AFX_MYDEPTHCODINGDIALOG_H__05951A45_F753_4804_810A_B79836D8FFAA__INCLUDED_)
#define AFX_MYDEPTHCODINGDIALOG_H__05951A45_F753_4804_810A_B79836D8FFAA__INCLUDED_

#include "gl/gl.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyDepthCodingDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyDepthCodingDialog dialog

//! Dialog for setting depth coding parameters.
class MyDepthCodingDialog : public CDialog
{
// Construction
public:
	//! Returns intensity of depth coding.
	int GetIntensity();
	//! Sets intensity of depth coding.
	void SetIntensity(int intensity);
	
	//! Returns depth coding color.
	void GetColor(GLubyte *color);
	//! Sets depth coding color.
	void SetColor(GLubyte *color);
	//! Sets depth coding type(color or depth cueing).
	void SetDepthType(int depthType);
	//! Returns depth coding type(color or depth cueing).
	int GetDepthType();

	//! Color dialog for setting depth coding color.
	CColorDialog m_ColorDialog;

	MyDepthCodingDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(MyDepthCodingDialog)
	enum { IDD = IDD_DEPTHCODINGDIALOG };
	int		m_DepthType;
	int		m_Intensity;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyDepthCodingDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyDepthCodingDialog)
	afx_msg void OnPaint();
	afx_msg void OnColorButton();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYDEPTHCODINGDIALOG_H__05951A45_F753_4804_810A_B79836D8FFAA__INCLUDED_)
