#if !defined(AFX_MYEDITREGIONSDIALOG_H__907C80AB_28DD_4EE1_882A_B88E8683D87E__INCLUDED_)
#define AFX_MYEDITREGIONSDIALOG_H__907C80AB_28DD_4EE1_882A_B88E8683D87E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyEditRegionsDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyEditRegionsDialog dialog
#include "MyMaterialDialog.h"
#include "Defines.h"
#include "StreamlineMaterial.h"
#include "MyHisto1Dialog.h"
#include "MyRegPropDialog.h"

//! Dialog class for specifying material regions used to show additional information.
class MyEditRegionsDialog : public CDialog
{
// Construction
public:
	//! Sets default region properties.
	void SetDefaultProp(RegProp &prop);
	//! Sets region properties for region with specified index.
	void SetRegProp(int index, RegProp &prop);
	//! Returns region properties for region with specified index.
	void GetRegProp(int index, RegProp &prop);

	//! Sets region material for region with specified index.
	void SetMaterial(int index, CStreamlineMaterial material);
	//! Returns region material for region with specified index.
	CStreamlineMaterial GetMaterial(int index);

	//! Maps scalar value to region index.
	static int MapValue2PropNr(RegProp *prop, int maxIndex, float value, 
							   float minValue, float maxValue);
	
	//! Sets region start position for region with specified index.
	void SetRegionPos(int index, float pos);
	//! Returns region start position for region with specified index.
	float GetRegionPos(int index);
	
	//! Returns resolution of region with specified index.
	int GetRes(int index);
	//! Sets resolution of region with specified index.
	void SetRes(int index, int res);

	//! Region properties dialogs.
	MyRegPropDialog m_RegPropDialog[DEF_REGIONS_NUM];
	//! Histogram dialog.
	MyHisto1Dialog m_Histo1Dialog;
	// Default region properties if region index not in range.
	RegProp m_DefaultProp;
	
	MyEditRegionsDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(MyEditRegionsDialog)
	enum { IDD = IDD_EDITREGIONSDIALOG };
	int		m_Region2;
	int		m_Region3;
	int		m_Region4;
	int		m_Region5;
	int		m_Region1;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyEditRegionsDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyEditRegionsDialog)
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	afx_msg void OnReleasedcaptureRegion1slider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnReleasedcaptureRegion2slider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnReleasedcaptureRegion3slider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnReleasedcaptureRegion4slider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnReleasedcaptureRegion5slider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnHistoButton();
	afx_msg void OnPropReg1Button();
	afx_msg void OnPropReg2Button();
	afx_msg void OnPropReg3Button();
	afx_msg void OnPropReg4Button();
	afx_msg void OnPropReg5Button();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYEDITREGIONSDIALOG_H__907C80AB_28DD_4EE1_882A_B88E8683D87E__INCLUDED_)
