// MyFieldSamplingDialog.cpp : implementation file
//

#include "stdafx.h"
#include "flow3d.h"
#include "MyFieldSamplingDialog.h"
#include "Defines.h"
#include "LorenzSampler.h"
#include "RoesslerSampler.h"
#include "TestSampler.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyFieldSamplingDialog dialog


MyFieldSamplingDialog::MyFieldSamplingDialog(CWnd* pParent /*=NULL*/)
	: CDialog(MyFieldSamplingDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(MyFieldSamplingDialog)
	m_IsSampleAddInfo = FALSE;
	m_SamplerType = -1;
	m_Param1 = 0.0f;
	m_Param2 = 0.0f;
	m_Param3 = 0.0f;
	m_XDim = 0;
	m_YDim = 0;
	m_ZDim = 0;
	//}}AFX_DATA_INIT
}


void MyFieldSamplingDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MyFieldSamplingDialog)
	DDX_Check(pDX, IDC_ADDINFOCHECK, m_IsSampleAddInfo);
	DDX_Radio(pDX, IDC_ROESSLERRADIO, m_SamplerType);
	DDX_Text(pDX, IDC_P1EDIT, m_Param1);
	DDX_Text(pDX, IDC_P2EDIT, m_Param2);
	DDX_Text(pDX, IDC_P3EDIT, m_Param3);
	DDX_Text(pDX, IDC_XDIMEDIT, m_XDim);
	DDV_MinMaxInt(pDX, m_XDim, 1, 1000);
	DDX_Text(pDX, IDC_YDIMEDIT, m_YDim);
	DDV_MinMaxInt(pDX, m_YDim, 1, 1000);
	DDX_Text(pDX, IDC_ZDIMEDIT, m_ZDim);
	DDV_MinMaxInt(pDX, m_ZDim, 1, 1000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MyFieldSamplingDialog, CDialog)
	//{{AFX_MSG_MAP(MyFieldSamplingDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyFieldSamplingDialog message handlers


float MyFieldSamplingDialog::GetParam1()
{
	return m_Param1;
}

float MyFieldSamplingDialog::GetParam2()
{
	return m_Param2;
}

float MyFieldSamplingDialog::GetParam3()
{
	return m_Param3;
}

void MyFieldSamplingDialog::SetParam1(float param1)
{
	m_Param1 = param1;
}

void MyFieldSamplingDialog::SetParam2(float param2)
{
	m_Param2 = param2;
}

void MyFieldSamplingDialog::SetParam3(float param3)
{
	m_Param3 = param3;
}

void MyFieldSamplingDialog::SetXDim(int xDim)
{
	m_XDim = xDim;
}

void MyFieldSamplingDialog::SetYDim(int yDim)
{
	m_YDim = yDim;
}

void MyFieldSamplingDialog::SetZDim(int zDim)
{
	m_ZDim = zDim;
}

int MyFieldSamplingDialog::GetSamplerType()
{
	return m_SamplerType;
}

void MyFieldSamplingDialog::SetSamplerType(int samplerType)
{
	m_SamplerType = samplerType;
}

int MyFieldSamplingDialog::GetXDim()
{
	return m_XDim;
}

int MyFieldSamplingDialog::GetYDim()
{
	return m_YDim;
}

int MyFieldSamplingDialog::GetZDim()
{
	return m_ZDim;
}

bool MyFieldSamplingDialog::GetIsSampleAddInfo()
{
	return (m_IsSampleAddInfo == TRUE);
}

void MyFieldSamplingDialog::SetIsSampleAddInfo(bool isSampleAddInfo)
{
	m_IsSampleAddInfo = isSampleAddInfo;
}

CSampler *MyFieldSamplingDialog::CreateSampler(int xDim, int yDim, int zDim,
											   float param1, float param2, float param3,
											   int samplerType, bool isSampleAddInfo)
{
	CSampler *result = NULL;

	int addSize = 0;
	if(isSampleAddInfo) addSize = 1;

	CPoint3D center((float)(xDim/2),(float)(yDim/2),(float)(zDim/2));
	
	if(samplerType == DEF_LORENZSAMPLER_INDEX)
	{
		result = new CLorenzSampler(center,param1,param2,param3, addSize);
	}
	else if(samplerType == DEF_ROESSLERSAMPLER_INDEX)
	{
		result = new CRoesslerSampler(center,param1,param2,param3,addSize);
	}
	else if(samplerType == DEF_TESTSAMPLER_INDEX)
	{
		result = new CTestSampler(center,param1,param2,addSize);
	}

	return result;
}
