#if !defined(AFX_MYFIELDSAMPLINGDIALOG_H__A88D4BFE_867E_4600_A79B_655C9D236C13__INCLUDED_)
#define AFX_MYFIELDSAMPLINGDIALOG_H__A88D4BFE_867E_4600_A79B_655C9D236C13__INCLUDED_

#include "Sampler.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyFieldSamplingDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyFieldSamplingDialog dialog

//! Dialog class for specifying field sampling values.
class MyFieldSamplingDialog : public CDialog
{
// Construction
public:
	//! Sets flag if additional scalar information should be sampled.
	void SetIsSampleAddInfo(bool isSampleAddInfo);
	//! Returns flag if additional scalar information should be sampled.
	bool GetIsSampleAddInfo();
	//! Returns z-dimension of field to be sampled.
	int GetZDim();
	//! Returns y-dimension of field to be sampled.
	int GetYDim();
	//! Returns x-dimension of field to be sampled.
	int GetXDim();
	//! Sets type of field sampling equations.
	void SetSamplerType(int samplerType);
	//! Returns type of field sampling equations.
	int GetSamplerType();
	//! Creates sampler-object that has CSampler as superclass.
	static CSampler *CreateSampler(int xDim, int yDim, int zDim,
								   float param1, float param2, float param3,
								   int samplerType, bool isSampleAddInfo);
	
	//! Sets z-dimension of field to be sampled.
	void SetZDim(int zDim);
	//! Sets y-dimension of field to be sampled.
	void SetYDim(int yDim);
	//! Sets x-dimension of field to be sampled.
	void SetXDim(int xDim);
	
	//! Sets parameter 3 of field sampling equations.
	void SetParam3(float param3);
	//! Sets parameter 2 of field sampling equations.
	void SetParam2(float param2);
	//! Sets parameter 1 of field sampling equations.
	void SetParam1(float param1);

	//! Returns parameter 3 of field sampling equations.
	float GetParam3();
	//! Returns parameter 2 of field sampling equations.
	float GetParam2();
	//! Returns parameter 1 of field sampling equations.
	float GetParam1();

	MyFieldSamplingDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(MyFieldSamplingDialog)
	enum { IDD = IDD_FIELDSAMPLINGDIALOG };
	BOOL	m_IsSampleAddInfo;
	int		m_SamplerType;
	float	m_Param1;
	float	m_Param2;
	float	m_Param3;
	int		m_XDim;
	int		m_YDim;
	int		m_ZDim;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyFieldSamplingDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyFieldSamplingDialog)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYFIELDSAMPLINGDIALOG_H__A88D4BFE_867E_4600_A79B_655C9D236C13__INCLUDED_)
