// MyHisto1Dialog.cpp : implementation file
//

#include "stdafx.h"
#include "flow3d.h"
#include "MyHisto1Dialog.h"
#include "FLOAT.H"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyHisto1Dialog dialog


MyHisto1Dialog::MyHisto1Dialog(CWnd* pParent /*=NULL*/)
	: CDialog(MyHisto1Dialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(MyHisto1Dialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	InitBarColors();
	for(int i = 0; i< DEF_REGIONS_NUM + 1; i++)
		m_Pos[i] = FLT_MAX;
}


void MyHisto1Dialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MyHisto1Dialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MyHisto1Dialog, CDialog)
	//{{AFX_MSG_MAP(MyHisto1Dialog)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyHisto1Dialog message handlers

void MyHisto1Dialog::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	if(m_IsRegions)
		DrawRegHisto();
	else
		DrawContTransfHisto();


	// Do not call CDialog::OnPaint() for painting messages
}

void MyHisto1Dialog::SetHistoData(CHistoData *histoData)
{
	m_HistoData = histoData;
}

void MyHisto1Dialog::InitBarColors()
{
	GLubyte barColor0[3] = DEF_BARCOL_REG1;
	GLubyte barColor1[3] = DEF_BARCOL_REG2;
	GLubyte barColor2[3] = DEF_BARCOL_REG3;
	GLubyte barColor3[3] = DEF_BARCOL_REG4;
	GLubyte barColor4[3] = DEF_BARCOL_REG5;
	GLubyte barColor5[3] = DEF_HISTO_BARCOLOR;
	
	m_BarColors[0] = barColor0[0] + 256*barColor0[1] + 256*256*barColor0[2];
	m_BarColors[1] = barColor1[0] + 256*barColor1[1] + 256*256*barColor1[2];
	m_BarColors[2] = barColor2[0] + 256*barColor2[1] + 256*256*barColor2[2];
	m_BarColors[3] = barColor3[0] + 256*barColor3[1] + 256*256*barColor3[2];
	m_BarColors[4] = barColor4[0] + 256*barColor4[1] + 256*256*barColor4[2];
	m_BarColors[5] = barColor5[0] + 256*barColor5[1] + 256*256*barColor5[2];
}

CFrameWnd * MyHisto1Dialog::GetFrame(int index)
{
	CFrameWnd *result;

	switch(index)
	{
		case 0:
			result = (CFrameWnd *)GetDlgItem( IDC_REG1_COL );
			break;
		case 1:
			result = (CFrameWnd *)GetDlgItem( IDC_REG2_COL );
			break;
		case 2:
			result = (CFrameWnd *)GetDlgItem( IDC_REG3_COL );
			break;
		case 3:
			result = (CFrameWnd *)GetDlgItem( IDC_REG4_COL );
			break;
		case 4:
			result = (CFrameWnd *)GetDlgItem( IDC_REG5_COL );
			break;
		default:
			result = (CFrameWnd *)GetDlgItem( IDC_REG1_COL );
			break;
	}

	return result;
}

void MyHisto1Dialog::DrawColorRect(int index)
{
	CFrameWnd *pHistoImage = GetFrame(index);

	CRect histoRect;
	
	pHistoImage->GetWindowRect(histoRect);
	CPaintDC myDC(pHistoImage); // device context for painting

	HDC hDC = myDC.GetSafeHdc();

	// Draw background
	for(int i=0;i<histoRect.Width();i++)
		for(int j=0;j<histoRect.Height();j++)
			SetPixel(hDC,i,j,m_BarColors[index]);

}

void MyHisto1Dialog::DrawRegHisto()
{
	CFrameWnd *pHistoImage = (CFrameWnd *)GetDlgItem( IDC_HISTOIMG );

	CRect histoRect;
	
	pHistoImage->GetWindowRect(histoRect);
	CPaintDC myDC(pHistoImage); // device context for painting

	HDC hDC = myDC.GetSafeHdc();

	GLubyte bkColor[3] = DEF_HISTO_BKCOLOR;

	int bkColInt = bkColor[0]+bkColor[1]*256+bkColor[2]*256*256;

	// Draw background
	for(int i=0;i<histoRect.Width();i++)
		for(int j=0;j<histoRect.Height();j++)
			SetPixel(hDC,i,j,bkColInt);

	int width = 1;
	
	if(m_HistoData->m_IntervNum > 0)
		width = histoRect.Width()/m_HistoData->m_IntervNum;

	if(width == 0)
		width = 1;
	CPen myPen[DEF_REGIONS_NUM + 1];
    
	for(i=0;i<DEF_REGIONS_NUM + 1;i++)
		myPen[i].CreatePen(PS_DOT, width, m_BarColors[i]);

    CPen* pOldPen = myDC.SelectObject(&myPen[0]);
		
	float factor = 0;
	if(m_HistoData[0].m_MaxDistr > 0)
		factor = (float)histoRect.Height() / (float)m_HistoData->m_MaxDistr;
   
	float pos = 0;
	int index = 0;

	for(i=0;i<m_HistoData->m_IntervNum;i++)
	{
		while(i > pos)
		{
			pos = m_Pos[index] * (float)m_HistoData->m_IntervNum;
			
			myDC.SelectObject(&myPen[index]);
			index++;
		}

		myDC.MoveTo(i * (width),histoRect.Height());
		myDC.LineTo(i * (width),histoRect.Height() - 
					(int)(m_HistoData->m_Distribution[i] * factor));
	}

	myDC.SelectObject(&pOldPen);

	for(i=0;i<DEF_REGIONS_NUM;i++)
		DrawColorRect(i);
}

void MyHisto1Dialog::DrawContTransfHisto()
{
	CFrameWnd *pHistoImage = (CFrameWnd *)GetDlgItem( IDC_HISTOIMG );

	CRect histoRect;
	
	pHistoImage->GetWindowRect(histoRect);
	CPaintDC myDC(pHistoImage); // device context for painting

	HDC hDC = myDC.GetSafeHdc();

	GLubyte bkColor[3] = DEF_HISTO_BKCOLOR;

	int bkColInt = bkColor[0]+bkColor[1]*256+bkColor[2]*256*256;

	// Draw background
	for(int i=0;i<histoRect.Width();i++)
		for(int j=0;j<histoRect.Height();j++)
			SetPixel(hDC,i,j,bkColInt);

	int width = 1;
	
	if(m_HistoData->m_IntervNum > 0)
		width = histoRect.Width()/m_HistoData->m_IntervNum;

	if(width == 0)
		width = 1;

	const int intervNum = m_HistoData->m_IntervNum; 
	CPen *myPen = new CPen[intervNum];
    
	float factor = 0;
	if(m_HistoData[0].m_MaxDistr > 0)
		factor = (float)histoRect.Height() / (float)m_HistoData->m_MaxDistr;
   
	float pos = 0;
	int index = 0;

	const int size = DEF_CONTTRANSFVALUES_NUM + 1;
	int colIndex = size - 1;

	GLubyte color[size][4];
	
	for(i = 0; i < DEF_CONTTRANSFVALUES_NUM; i++)
			for(int j = 0; j < 4; j++)
				color[i][j] = m_ContProp[i].rgba[j];
	
	for(i=0;i<m_HistoData->m_IntervNum;i++)
	{
		
		MapValue2Color_3(color[colIndex],color[0],color[1],color[2],
					    (float)i,0.0f,m_InterPos,(float)m_HistoData->m_IntervNum);

		long colInt = color[colIndex][0]+color[colIndex][1]*256+
					  color[colIndex][2]*256*256;

		myPen[i].CreatePen(PS_DOT, width, colInt);

		myDC.SelectObject(&myPen[i]);
			
		myDC.MoveTo(i * (width),histoRect.Height());
		myDC.LineTo(i * (width),histoRect.Height() - 
					(int)(m_HistoData->m_Distribution[i] * factor));
	}

	delete [] myPen;
}

void MyHisto1Dialog::MapValue2Color_3(GLubyte *rgba, GLubyte *minRGBA, GLubyte *middleRGBA, 
									  GLubyte *maxRGBA, float value, float minValue, 
									  float middlePos, float maxValue)
{
	float middleValue = minValue + (maxValue - minValue) * middlePos;

	if(value < middleValue)
		MapValue2Color(rgba,minRGBA,middleRGBA,value,0.0f,middleValue);
	else
		MapValue2Color(rgba,middleRGBA,maxRGBA,value,middleValue,maxValue);

}

void MyHisto1Dialog::MapValue2Color(GLubyte *rgba, GLubyte *minRGBA, GLubyte *maxRGBA,
									float value, float minValue, float maxValue)
{
	float factor = 1.0f;
	float dif = maxValue - minValue;

	if(dif != 0)
		factor = (value - minValue)/dif;

	for(int i=0;i<4;i++)
		rgba[i] = (GLubyte)(minRGBA[i] + ((float)maxRGBA[i] - (float)minRGBA[i]) * factor);
}