#if !defined(AFX_MYHISTO1DIALOG_H__03A1B6A9_600A_4B1B_849E_89A4006A4AB5__INCLUDED_)
#define AFX_MYHISTO1DIALOG_H__03A1B6A9_600A_4B1B_849E_89A4006A4AB5__INCLUDED_
#include "MyContTransfPropDialog.h"	// Added by ClassView
#include "HistoData.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyHisto1Dialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyHisto1Dialog dialog

//! Histogram dialog used for setting scalar representation.
class MyHisto1Dialog : public CDialog
{
// Construction
public:
	//! Maps scalar value to color of transfer function with three defining points.
	static void MapValue2Color_3(GLubyte *rgba, GLubyte *minRGBA, GLubyte *middleRGBA, 
								 GLubyte *maxRGBA,float value, float minValue, 
								 float middlePos, float maxValue);
	
	//! Maps scalar value to color of transfer function with two defining points.
	static void MapValue2Color(GLubyte *rgba, GLubyte *minRGBA, GLubyte *maxRGBA,
							   float value, float minValue,float maxValue);

	//! Draws histogram for continuous transfer function scalar representation.
	void DrawContTransfHisto();
	//! Draws histogram for scalar regions representation. 
	void DrawRegHisto();

	//! Sets histogram data.
	void SetHistoData(CHistoData *histoData);

	//! Standard constructor.
	MyHisto1Dialog(CWnd* pParent = NULL);

	//! Histogram data.
	CHistoData * m_HistoData;

	//! Continuous transfer function properties.
	ContTransfProp m_ContProp[DEF_CONTTRANSFVALUES_NUM];

	//! Flag which indicates that scalar region are used.
	bool m_IsRegions;
	//! Color of histogram bars in scalar regions representation.
	int m_BarColors[DEF_REGIONS_NUM+1];
	//! Region position values in scalar regions representation.
	float m_Pos[DEF_REGIONS_NUM + 1];
	//! Intermediate properties position in continuous transfer function.
	float m_InterPos;

private:
	void DrawColorRect(int index);
	CFrameWnd * GetFrame(int index);
	void InitBarColors();
// Dialog Data
	//{{AFX_DATA(MyHisto1Dialog)
	enum { IDD = IDD_HISTO1_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyHisto1Dialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyHisto1Dialog)
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYHISTO1DIALOG_H__03A1B6A9_600A_4B1B_849E_89A4006A4AB5__INCLUDED_)
