#if !defined(AFX_MYHISTODIALOG_H__3BDFBC4F_FE75_4131_BA1D_88603C28FAF6__INCLUDED_)
#define AFX_MYHISTODIALOG_H__3BDFBC4F_FE75_4131_BA1D_88603C28FAF6__INCLUDED_

#include "HistoData.h"
#include "HistoDataStream.h"
#include "gl/gl.h"
#include "gl/glu.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyHistoDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyHistoDialog dialog

//! Histogram dialog.
class MyHistoDialog : public CDialog
{
// Construction
public:
	//! Sets mininal and maximal scalar values.
	void SetMinMaxScalar(float minScalar, float maxScalar);
	//! Sets type of scalar.
	void SetScalarType(int scalarType);
	//! Updates data and graphics.
	void UpdateGraphs();
	//! Updates histogram data.
	void UpdateData();

	//! Number of histogram data intervals.
	int m_IntervNum;

	//! Scalar type.
	int m_ScalarType;

	//! Dialog title string.
	char m_Title[100];

	//! Initialises histogram data streams.
	void InitDataStreams(CObList *list);

	// Histogram data for different regions and modes.
	CHistoData m_HistoData[DEF_HISTOIMG_NUM];

	//! Histogram data streams for different regions and modes.
	CHistoDataStream m_HistoDataStream[DEF_HISTOIMG_NUM];

	MyHistoDialog(CWnd* pParent = NULL);

private:
	CFrameWnd * GetFrame(int index);
	DrawHisto(int index, GLubyte *barColor, int bkColor);
// Dialog Data
	//{{AFX_DATA(MyHistoDialog)
	enum { IDD = IDD_HISTODIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyHistoDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyHistoDialog)
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYHISTODIALOG_H__3BDFBC4F_FE75_4131_BA1D_88603C28FAF6__INCLUDED_)
