// MyLineStyleDialog.cpp : implementation file
//

#include "stdafx.h"
#include "flow3d.h"
#include "MyLineStyleDialog.h"
#include "Defines.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyLineStyleDialog dialog


MyLineStyleDialog::MyLineStyleDialog(CWnd* pParent /*=NULL*/)
	: CDialog(MyLineStyleDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(MyLineStyleDialog)
	m_LineWidth = 0;
	m_IsTapering = FALSE;
	m_IsAntiAliasing = FALSE;
	m_PeriodLength = 0;
	m_TranspFuncType = -1;
	m_Absorption = 0;
	m_IsTranspFunc = FALSE;
	m_IsGap = FALSE;
	m_GapSize = 0;
	m_EndTapWidth = 0;
	m_IsEndTap = FALSE;
	m_ArrowLength = 0;
	m_ArrowWidth = 0;
	m_IsArrows = FALSE;
	m_ArPeriod = 0;
	m_ArrowType = -1;
	//}}AFX_DATA_INIT
}


void MyLineStyleDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MyLineStyleDialog)
	DDX_Slider(pDX, IDC_LINEWIDTHSLIDER, m_LineWidth);
	DDX_Check(pDX, IDC_TAPERINGCHECK, m_IsTapering);
	DDX_Check(pDX, IDC_ISNANTIALIASINGCHECK, m_IsAntiAliasing);
	DDX_Slider(pDX, IDC_PERIODLENGTHSLIDER, m_PeriodLength);
	DDX_Radio(pDX, IDC_HAZE_LIN_RADIO, m_TranspFuncType);
	DDX_Slider(pDX, IDC_ABSORBTIONSLIDER, m_Absorption);
	DDX_Check(pDX, IDC_TRANSPARENCYCHECK, m_IsTranspFunc);
	DDX_Check(pDX, IDC_GAPCHECK, m_IsGap);
	DDX_Slider(pDX, IDC_GAPSLIDER, m_GapSize);
	DDX_Slider(pDX, IDC_ENDTAP_WIDTHSLIDER, m_EndTapWidth);
	DDX_Check(pDX, IDC_ENDTAPCHECK, m_IsEndTap);
	DDX_Slider(pDX, IDC_ARROW_LENGTHSLIDER, m_ArrowLength);
	DDX_Slider(pDX, IDC_ARROW_WIDTHSLIDER, m_ArrowWidth);
	DDX_Check(pDX, IDC_ISARROWSCHECK, m_IsArrows);
	DDX_Slider(pDX, IDC_AR_PERIODSLIDER, m_ArPeriod);
	DDX_Radio(pDX, IDC_AR_LENDRADIO, m_ArrowType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MyLineStyleDialog, CDialog)
	//{{AFX_MSG_MAP(MyLineStyleDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyLineStyleDialog message handlers

float MyLineStyleDialog::GetLineWidth()
{
	return m_LineWidth/DEF_LINEWIDTHSLIDER_FACTOR;
}

bool MyLineStyleDialog::GetIsAntiAliasing()
{
	return (m_IsAntiAliasing==TRUE);
}

bool MyLineStyleDialog::GetIsTapering()
{
	return (m_IsTapering == TRUE);
}

void MyLineStyleDialog::SetIsAntiAliasing(bool isAntiAliasing)
{
	m_IsAntiAliasing = isAntiAliasing;
}

void MyLineStyleDialog::SetIsTapering(bool isTapering)
{
	m_IsTapering = isTapering;
}

void MyLineStyleDialog::SetLineWidth(float lineWidth)
{
	m_LineWidth = (int)(lineWidth*(float)DEF_LINEWIDTHSLIDER_FACTOR);
}

BOOL MyLineStyleDialog::OnInitDialog() 
{
	CSliderCtrl * pLineWidthSlider = (CSliderCtrl*)GetDlgItem( IDC_LINEWIDTHSLIDER );
	CSliderCtrl * pPeriodLengthSlider = (CSliderCtrl*)GetDlgItem( IDC_PERIODLENGTHSLIDER );
	CSliderCtrl * pAbsorptionSlider = (CSliderCtrl*)GetDlgItem( IDC_ABSORBTIONSLIDER );
	CSliderCtrl * pGapSlider = (CSliderCtrl*)GetDlgItem( IDC_GAPSLIDER );
	CSliderCtrl * pEndTapWidthSlider = (CSliderCtrl*)GetDlgItem( IDC_ENDTAP_WIDTHSLIDER );
	CSliderCtrl * pArrowLengthSlider = (CSliderCtrl*)GetDlgItem( IDC_ARROW_LENGTHSLIDER );
	CSliderCtrl * pArrowWidthSlider = (CSliderCtrl*)GetDlgItem( IDC_ARROW_WIDTHSLIDER );
	CSliderCtrl * pArPeriodSlider = (CSliderCtrl*)GetDlgItem( IDC_AR_PERIODSLIDER );

	pLineWidthSlider->SetRange(DEF_LINEWIDTHSLIDER_MIN, DEF_LINEWIDTHSLIDER_MAX);
	pAbsorptionSlider->SetRange(DEF_ABSORPTIONSLIDER_MIN, DEF_ABSORPTIONSLIDER_MAX);
	pPeriodLengthSlider->SetRange(DEF_PERIODLENGTHSLIDER_MIN, DEF_PERIODLENGTHSLIDER_MAX);
	pGapSlider->SetRange(DEF_GAPSLIDER_MIN, DEF_GAPSLIDER_MAX);
	pEndTapWidthSlider->SetRange(DEF_ENDTAP_WIDTHSLIDER_MIN, DEF_ENDTAP_WIDTHSLIDER_MAX);
	pArrowLengthSlider->SetRange(DEF_ARROWLENGTHSLIDER_MIN, DEF_ARROWLENGTHSLIDER_MAX );
	pArrowWidthSlider->SetRange(DEF_ARROWWIDTHSLIDER_MIN, DEF_ARROWWIDTHSLIDER_MAX );
	pArPeriodSlider->SetRange(DEF_AR_PERIODSLIDER_MIN, DEF_AR_PERIODSLIDER_MAX );

	pLineWidthSlider->SetTic(DEF_LINEWIDTHSLIDER_MAX/2);
	pAbsorptionSlider->SetTic(DEF_ABSORPTIONSLIDER_MAX/2);
	pPeriodLengthSlider->SetTic(DEF_PERIODLENGTHSLIDER_MAX/2);
	pGapSlider->SetTic(DEF_GAPSLIDER_MAX/2);
	pEndTapWidthSlider->SetTic(DEF_ENDTAP_WIDTHSLIDER_MAX/2);
	pArrowLengthSlider->SetTic(DEF_ARROWLENGTHSLIDER_MAX/2);
	pArrowWidthSlider->SetTic(DEF_ARROWWIDTHSLIDER_MAX/2);
	pArPeriodSlider->SetTic(DEF_AR_PERIODSLIDER_MAX/2);

	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int MyLineStyleDialog::GetPeriodLength()
{
	return m_PeriodLength;
}

bool MyLineStyleDialog::GetIsTranspFunc()
{
	return (m_IsTranspFunc==TRUE);
}

int MyLineStyleDialog::GetTranspFuncType()
{
	return m_TranspFuncType;
}

void MyLineStyleDialog::SetPeriodLength(int periodLength)
{
	m_PeriodLength = periodLength;
}

void MyLineStyleDialog::SetIsTranspFunc(bool isTranspFunc)
{
	m_IsTranspFunc = isTranspFunc;
}

void MyLineStyleDialog::SetTranspFuncType(int transpFuncType)
{
	m_TranspFuncType = transpFuncType;
}

GLubyte MyLineStyleDialog::GetAbsorption()
{
	return (GLubyte)m_Absorption;
}

void MyLineStyleDialog::SetAbsorption(GLubyte absorption)
{
	m_Absorption = (int)absorption;
}

void MyLineStyleDialog::SetGapSize(float gapSize)
{
	m_GapSize = (int)(gapSize * DEF_GAPSLIDER_FACTOR);
}

float MyLineStyleDialog::GetGapSize()
{
	return (float)m_GapSize / DEF_GAPSLIDER_FACTOR;
}

void MyLineStyleDialog::SetIsGap(bool isGap)
{
	m_IsGap = isGap;
}

bool MyLineStyleDialog::GetIsGap()
{
	return (m_IsGap == TRUE);
}

int MyLineStyleDialog::GetEndTapWidth()
{
	return m_EndTapWidth;
}

void MyLineStyleDialog::SetEndTapWidth(int width)
{
	m_EndTapWidth = width;
}

void MyLineStyleDialog::SetIsEndTap(bool isEndTap)
{
	m_IsEndTap = isEndTap;
}

bool MyLineStyleDialog::GetIsEndTap()
{
	return (m_IsEndTap == TRUE);
}

bool MyLineStyleDialog::GetIsArrows()
{
	return (m_IsArrows==TRUE);
}

void MyLineStyleDialog::SetIsArrows(bool isArrows)
{
	m_IsArrows = isArrows;
}

void MyLineStyleDialog::SetArrowWidth(float width)
{
	m_ArrowWidth = (int)(width * DEF_ARROWWIDTHSLIDER_FACTOR);
}

void MyLineStyleDialog::SetArrowLength(float length)
{
	m_ArrowLength = (int)(length * DEF_ARROWLENGTHSLIDER_FACTOR);
}

float MyLineStyleDialog::GetArrowLength()
{
	return (float)m_ArrowLength / DEF_ARROWLENGTHSLIDER_FACTOR;
}

float MyLineStyleDialog::GetArrowWidth()
{
	return (float)m_ArrowWidth / DEF_ARROWWIDTHSLIDER_FACTOR;
}

int MyLineStyleDialog::GetArrowPeriod()
{
	return m_ArPeriod;
}

void MyLineStyleDialog::SetArrowPeriod(int period)
{
	m_ArPeriod = period;
}

void MyLineStyleDialog::SetArrowType(int type)
{	
	m_ArrowType = type;
}

int MyLineStyleDialog::GetArrowType()
{
	return m_ArrowType;
}
