#if !defined(AFX_MYLINESTYLEDIALOG_H__0C747218_087A_4264_A2C9_E91E4D125E9F__INCLUDED_)
#define AFX_MYLINESTYLEDIALOG_H__0C747218_087A_4264_A2C9_E91E4D125E9F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyLineStyleDialog.h : header file
//

#include "gl/gl.h"

/////////////////////////////////////////////////////////////////////////////
// MyLineStyleDialog dialog

//! Dialog class for specifying line style parameters.
class MyLineStyleDialog : public CDialog
{
// Construction
public:
	int GetArrowType();
	void SetArrowType(int type);
	void SetArrowPeriod(int period);
	int GetArrowPeriod();
	//! Returns width of streamline arrows.
	float GetArrowWidth();
	//! Returns length of streamline arrows.
	float GetArrowLength();
	//! Sets length of streamline arrows.
	void SetArrowLength(float length);
	//! Returns length of streamline arrows.
	void SetArrowWidth(float width);
	//! Sets flag which indicates if arrows should be used.
	void SetIsArrows(bool isArrows);
	//! Returns flag which indicates if arrows should be used.
	bool GetIsArrows();
	//! Returns flag which indicates if end tapering should be used.
	bool GetIsEndTap();
	//! Sets floag which indicates if end tapering should be used.
	void SetIsEndTap(bool isEndTap);
	//! Sets end tapering width(in number of samplepoints).
	void SetEndTapWidth(int width);
	//! Returns end tapering width(in number of samplepoints).
	int GetEndTapWidth();
	//! Returns flag which indicates if gaps should be drawn.
	bool GetIsGap();
	//! Sets floag which indicates if gaps should be drawn.
	void SetIsGap(bool isGap);
	//! Returns gap size.
	float GetGapSize();
	//! Sets gap size.
	void SetGapSize(float gapSize);
	//! Sets absorption factor of haze exp. transparency function.
	void SetAbsorption(GLubyte absorption);
	//! Returns absorption factor of haze exp. transarency function.
	GLubyte GetAbsorption();
	//! Sets type of transparency function.
	void SetTranspFuncType(int type);
	//! Sets flag which indicates if transp. functions are used.
	void SetIsTranspFunc(bool isTranspFunc);
	//! Sets haze lin., sinus transp. function period length.
	void SetPeriodLength(int periodLength);
	//! Returns type of transparency function.
	int GetTranspFuncType();
	//! Returns flag which indicates if transp. function are used.
	bool GetIsTranspFunc();
	//! Sets haze lin., sinus transp. functions period length.
	int GetPeriodLength();
	//! Sets line width.
	void SetLineWidth(float lineWidth);
	//! Sets flag which indicates if tapering is used.
	void SetIsTapering(bool isTapering);
	//! Sets flag which indicates if line antialiasing is used.
	void SetIsAntiAliasing(bool isAntiAliasing);
	//! Returns flag which indicates if line antialiasing is used.
	bool GetIsAntiAliasing();
	//! Returns flag whihc indicates if tapering is used.
	bool GetIsTapering();
	//! Returns line width.
	float GetLineWidth();

	MyLineStyleDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(MyLineStyleDialog)
	enum { IDD = IDD_LINESTYLEDIALOG };
	int		m_LineWidth;
	BOOL	m_IsTapering;
	BOOL	m_IsAntiAliasing;
	int		m_PeriodLength;
	int		m_TranspFuncType;
	int		m_Absorption;
	BOOL	m_IsTranspFunc;
	BOOL	m_IsGap;
	int		m_GapSize;
	int		m_EndTapWidth;
	BOOL	m_IsEndTap;
	int		m_ArrowLength;
	int		m_ArrowWidth;
	BOOL	m_IsArrows;
	int		m_ArPeriod;
	int		m_ArrowType;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyLineStyleDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyLineStyleDialog)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYLINESTYLEDIALOG_H__0C747218_087A_4264_A2C9_E91E4D125E9F__INCLUDED_)
