#if !defined(AFX_MYMATERIALDIALOG_H__E8B9FADF_53F4_47C4_8F70_7F685C050ADF__INCLUDED_)
#define AFX_MYMATERIALDIALOG_H__E8B9FADF_53F4_47C4_8F70_7F685C050ADF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyMaterialDialog.h : header file
//
#include "gl/glu.h"
#include "gl/gl.h"
#include "StreamlineMaterial.h"

/////////////////////////////////////////////////////////////////////////////
// MyMaterialDialog dialog

//! Dialog class for specifying streamline material.
class MyMaterialDialog : public CDialog
{
// Construction
public:
	//! Returns streamline opacity.
	GLubyte GetOpacity();
	//! Sets streamline opacity.
	void SetOpacity(GLubyte opacity);
	//! Sets material specular component.
	void SetSpecularRGB(GLubyte *specularRGB);
	//! Sets material diffuse component.
	void SetDiffuseRGB(GLubyte *diffuseRGB);
	//! Sets material ambient component.
	void SetAmbientRGB(GLubyte *ambientRGB);
	//! Returns material specular component.
	void GetSpecularRGB(GLubyte *specularRGB);
	//! Returns material diffuse component.
	void GetDiffuseRGB(GLubyte *diffuseRGB);
	//! Returns material ambient component.
	void GetAmbientRGB(GLubyte *ambientRGB);
	
	//! Sets material.
	void SetMaterial(CStreamlineMaterial material);
	//! Returns material.
	CStreamlineMaterial GetMaterial();

	//! Specular color component dialog.
	CColorDialog m_SpecularDialog;
	//! Diffuse color component dialog.
	CColorDialog m_DiffuseDialog;
	//! Ambient color component dialog.
	CColorDialog m_AmbientDialog;
	
	//! Standard constructor.
	MyMaterialDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(MyMaterialDialog)
	enum { IDD = IDD_MATERIALDIALOG };
	int		m_Opacity;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyMaterialDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyMaterialDialog)
	afx_msg void OnAmbientbutton();
	afx_msg void OnDiffusebutton();
	afx_msg void OnSpecularbutton();
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYMATERIALDIALOG_H__E8B9FADF_53F4_47C4_8F70_7F685C050ADF__INCLUDED_)
