// MyObject.h: interface for the MyObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYOBJECT_H__01F7ED7C_2DAA_4FE0_A4DB_3B0C6B8DCB85__INCLUDED_)
#define AFX_MYOBJECT_H__01F7ED7C_2DAA_4FE0_A4DB_3B0C6B8DCB85__INCLUDED_
#include "gl/gl.h"
#include "Point3D.h"	// Added by ClassView

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//! Class representing a geometrical object in 3D.
class MyObject  
{
public:
	//! Initialisation of this object with another object.
	virtual void Init(MyObject *obj) = 0;
	//! Returns line width used for drawing object.
	float GetLineWidth();
	//! Returns current position of this object.
	CPoint3D GetPosition();
	//! Returns rgba-value of this object.
	void GetRgba(GLubyte *rgba);
	
	//! Sets line width used for drawing object.
	virtual void SetLineWidth(float lineWidth);
	//! Sets current position of this object.
	virtual void SetPosition(CPoint3D position);
	//! Sets color and opacity of this object.
	virtual void SetRgba(GLubyte *rgba);
	
	//! Draw function for drawing this object in window using OpenGL.
	virtual void Draw() = 0;
	//! Test if pos is inside or outside object.
	virtual bool IsInside(CPoint3D pos) = 0;

	MyObject();
	virtual ~MyObject();

protected:
	CPoint3D m_Position;
	GLubyte m_Rgba[4];
	float m_LineWidth;

};

#endif // !defined(AFX_MYOBJECT_H__01F7ED7C_2DAA_4FE0_A4DB_3B0C6B8DCB85__INCLUDED_)
