// MyRectangle.h: interface for the MyRectangle class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYRECTANGLE_H__229F99AF_C3E2_48FE_8A6E_0D8A57B310E5__INCLUDED_)
#define AFX_MYRECTANGLE_H__229F99AF_C3E2_48FE_8A6E_0D8A57B310E5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyObject.h"
#include "Point3D.h"	// Added by ClassView

//! Class representing a rectangle.
class MyRectangle : public MyObject  
{
public:
	//! Returns rectangle length.
	float GetLength();
	//! Returns rectangle width.
	float GetWidth();
	//! Returns rectangle height.
	float GetHeight();
	virtual void Init(MyObject *obj);
	//! Returns point with maximal xyz-coordinates.
	CPoint3D GetMaxPoint();
	//! Returns point with minimal xyz-coordinates.
	CPoint3D GetMinPoint();
	//! Sets rectangle height.
	void SetHeight(float height);
	//! Sets rectangle width.
	void SetWidth(float width);
	//! Sets rectangle length.
	void SetLength(float length);
	
	//! Constructor intialising position, size, line width, rgba.
	MyRectangle(CPoint3D position, float length,float width,
				float height,float lineWidth, GLubyte *rgba);

	//! Standard constructor.
	MyRectangle();

	virtual void Draw();
	virtual bool IsInside(CPoint3D pos);
	virtual void SetPosition(CPoint3D position);

	virtual ~MyRectangle();

protected:
	void UpdateMinPoint();
	void UpdateMaxPoint();

	CPoint3D m_MinPoint;
	CPoint3D m_MaxPoint;

	float m_Length;
	float m_Height;
	float m_Width;
};

#endif // !defined(AFX_MYRECTANGLE_H__229F99AF_C3E2_48FE_8A6E_0D8A57B310E5__INCLUDED_)
