#if !defined(AFX_MYREGPROPDIALOG_H__5246FC97_801E_4303_9142_F4F53317DE3C__INCLUDED_)
#define AFX_MYREGPROPDIALOG_H__5246FC97_801E_4303_9142_F4F53317DE3C__INCLUDED_

#include "MyMaterialDialog.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyRegPropDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyRegPropDialog dialog

//! Structure which holds scalar region properties.
struct RegProp
{ 
	//! Region material.
	CStreamlineMaterial material;
	//! Region line width.
	float lineWidth;
	//! Region streamline resolution.
	int res;
	//! Region streamline resolution index.
	int resIndex;
	//! Region start position.
	float pos;
};

//! Dialog for specifying scalar region properties.
class MyRegPropDialog : public CDialog
{
// Construction
public:
	//! Returns region line width.
	float GetLineWidth();
	//! Sets region line width.
	void SetLineWidth(float lineWidth);
	//! Returns region streamline resolution.
	int GetRes();
	//! Sets region streamline resolution.
	void SetRes(int res);

	//! Dialog for setting region material.
	MyMaterialDialog m_MaterialDialog;

	//! Standard constructor.
	MyRegPropDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(MyRegPropDialog)
	enum { IDD = IDD_REG_PROP_DIALOG };
	int		m_Res;
	int		m_LineWidth;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyRegPropDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyRegPropDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnMaterialButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYREGPROPDIALOG_H__5246FC97_801E_4303_9142_F4F53317DE3C__INCLUDED_)
