// MySphere.h: interface for the MySphere class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYSPHERE_H__B2B8B6D8_7132_41E3_83A0_A37311F9DF46__INCLUDED_)
#define AFX_MYSPHERE_H__B2B8B6D8_7132_41E3_83A0_A37311F9DF46__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyObject.h"
#include "gl/glu.h"

//! Class representing a sphere.
class MySphere : public MyObject  
{
public:
	virtual void Init(MyObject *obj);

	//! Constructor initialising position, radius, line width.
	MySphere(CPoint3D position, float radius, float lineWidth, 
			 GLubyte *rgba);

	virtual bool IsInside(CPoint3D position);
	virtual void Draw();

	//! Returns radius of sphere.
	float GetRadius();
	//! Sets radius of sphere.
	void SetRadius(float radius);

	//! Standard constructor.
	MySphere();

	virtual ~MySphere();
private:
	float m_Radius;
	float m_QuadRadius;
};

#endif // !defined(AFX_MYSPHERE_H__B2B8B6D8_7132_41E3_83A0_A37311F9DF46__INCLUDED_)
