// Point3D.cpp: implementation of the CPoint3D class.
//
//////////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "Flow3D.h"
#include "Point3D.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPoint3D::CPoint3D()
{

	m_XPos = 0.0f;
	m_YPos = 0.0f;
	m_ZPos = 0.0f;
	
}

CPoint3D::CPoint3D(float xPos,float yPos,float zPos)
{
	m_XPos = xPos;
	m_YPos = yPos;
	m_ZPos = zPos;
}

CPoint3D::~CPoint3D()
{

}


float CPoint3D::QuadDistance(CPoint3D &p)
{
	return ((m_XPos-p.m_XPos)*(m_XPos-p.m_XPos)+
			(m_YPos-p.m_YPos)*(m_YPos-p.m_YPos)+
			(m_ZPos-p.m_ZPos)*(m_ZPos-p.m_ZPos));
}

float CPoint3D::Distance(CPoint3D &p)
{
	return	(float)sqrt((m_XPos-p.m_XPos)*(m_XPos-p.m_XPos)+
						(m_YPos-p.m_YPos)*(m_YPos-p.m_YPos)+
						(m_ZPos-p.m_ZPos)*(m_ZPos-p.m_ZPos));
}

void CPoint3D::SetPos(float xPos, float yPos, float zPos)
{
	m_XPos = xPos;
	m_YPos = yPos;
	m_ZPos = zPos;
}

float CPoint3D::GetYPos()
{
	return m_YPos;
}

float CPoint3D::GetZPos()
{
	return m_ZPos;
}

float CPoint3D::GetXPos()
{
	return m_XPos;
}

bool CPoint3D::Inside(CPoint3D min, CPoint3D max)
{
	bool result = true;
	if(((max.m_XPos - m_XPos) < 0) ||
	   ((max.m_YPos - m_YPos) < 0) ||
	   ((max.m_ZPos - m_ZPos) < 0) ||
	   ((m_XPos - min.m_XPos) < 0) ||
	   ((m_YPos - min.m_YPos) < 0) ||
	   ((m_ZPos - min.m_ZPos) < 0))
	{
	   result = false;
	}

	return result;
}