// Point3D.h: interface for the CPoint3D class.
//
//////////////////////////////////////////////////////////////////////
#include <math.h>

#if !defined(AFX_POINT3D_H__EB68C873_4256_4D30_A089_74E3E622D626__INCLUDED_)
#define AFX_POINT3D_H__EB68C873_4256_4D30_A089_74E3E622D626__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//! A class representing a point in 3 dimensions.
class CPoint3D  
{
public:
	// True if point is inside boundaries of rectangle defined by parameters.
	bool Inside(CPoint3D min, CPoint3D max);
	//! Returns position in x-direction
	float GetZPos();
	//! Returns position in y-direction
	float GetYPos();
	//! Returns position in z-direction
	float GetXPos();
	//! Sets position values.
	void SetPos(float xPos,float yPos,float zPos);
	//! Computes euclidian distance.
	float Distance(CPoint3D &p);
	//! Computes quadratic euclidian distance(used for performance reasons).
	float QuadDistance(CPoint3D &p);
	
	CPoint3D();
	CPoint3D(float xPos,float yPos,float zPos);
	virtual ~CPoint3D();

	//! position value in z-direction
	float m_ZPos;
	//! position value in y-direction
	float m_YPos;
	//! position value in x-direction
	float m_XPos;
};

#endif // !defined(AFX_POINT3D_H__EB68C873_4256_4D30_A089_74E3E622D626__INCLUDED_)
