// RectTrilinVLength.h: interface for the CRectTrilinVLength class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RECTTRILINVLENGTH_H__06B098AA_75FD_4AC3_8D3F_9CAC9FDD8382__INCLUDED_)
#define AFX_RECTTRILINVLENGTH_H__06B098AA_75FD_4AC3_8D3F_9CAC9FDD8382__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Interpolator.h"

//! A class implementing a trilinear interpolator for rectilinear grids.
/*!	This interpolator works not only for cartesian grids, but also for
	rectilinear grids(distance between grid points not necessarily =1).
	Note that it interpolates vector and vector length separately.
*/

class CRectTrilinVLength : public CInterpolator  
{
public:
	CRectTrilinVLength();
	virtual ~CRectTrilinVLength();
	virtual void Interpolate(CSamplePoint *sp, CPoint3D &position,CSamplePoint ** neighbour);
	
private:
	CPoint3D m_CurrentPos;
	CSamplePoint m_HSampleP[6];
	void LinearInterpolate(CSamplePoint *sp,int axis,CPoint3D &position,CSamplePoint *s1,CSamplePoint *s2);
};

#endif // !defined(AFX_RECTTRILINVLENGTH_H__06B098AA_75FD_4AC3_8D3F_9CAC9FDD8382__INCLUDED_)
