// RectTrilinear.h: interface for the CRectTrilinear class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RECTTRILINEAR_H__24E7B1DA_18C2_4F6C_AF0D_0665AE0C74A5__INCLUDED_)
#define AFX_RECTTRILINEAR_H__24E7B1DA_18C2_4F6C_AF0D_0665AE0C74A5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Interpolator.h"
#include "SamplePoint.h"	// Added by ClassView

//! A class implementing a trilinear interpolator for rectilinear grids.
/*! This interpolator works not only for cartesian grids, but also for
	rectilinear grids(distance between grid points not necessarily =1)
	Unlike CRectTrilinVLength, the vector length is not interpolated 
	separately.
*/

class CRectTrilinear : public CInterpolator  
{
public:
	CRectTrilinear();
	virtual void Interpolate(CSamplePoint *sp, CPoint3D &position,CSamplePoint ** neighbour);
	virtual ~CRectTrilinear();

private:
	CSamplePoint m_HSampleP[6];
	void LinearInterpolate(CSamplePoint *sp, int axis,CPoint3D &position,CSamplePoint *s1,CSamplePoint *s2);
	CPoint3D m_CurrentPos;
};

#endif // !defined(AFX_RECTTRILINEAR_H__24E7B1DA_18C2_4F6C_AF0D_0665AE0C74A5__INCLUDED_)
