// RungeKutta2Op.h: interface for the CRungeKutta2 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RUNGEKUTTA2_H__C116134F_0C67_4F2B_88B4_0454D02A480F__INCLUDED_)
#define AFX_RUNGEKUTTA2_H__C116134F_0C67_4F2B_88B4_0454D02A480F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Integrator.h"

//! This class implements the Runge-Kutta integrator of 2th grade.
/*! Runge-Kutta2 is better than Euler but requires a little more computation.*/
class CRungeKutta2Op : public CIntegrator  
{
public:
	//! Sets dt(=value for one timestep)
	virtual void SetDt(float dt);
	//! Constructor with pointer to vectorfield, pointer to interpolator and dt as parameters
	CRungeKutta2Op::CRungeKutta2Op(CVectorField *vectorField,CInterpolator *interpolator,float dt);
	CRungeKutta2Op();
	virtual ~CRungeKutta2Op();
	//! Makes one integration-step and returns pointer to new samplepoint.
	virtual CSamplePoint *ComputeNext(CSamplePoint *lastPoint);
private:
	CPoint3D m_Pos;
	CSamplePoint m_InterPoint;

	float m_DtDiv2;
};

#endif // !defined(AFX_RUNGEKUTTA2_H__C116134F_0C67_4F2B_88B4_0454D02A480F__INCLUDED_)
