// Sampler.h: interface for the CSampler class.
//
//////////////////////////////////////////////////////////////////////
#include "SamplePoint.h"
#include "Vector3D.h"	// Added by ClassView

#if !defined(AFX_SAMPLER_H__59182004_8B9B_4575_910F_A87D5F78A039__INCLUDED_)
#define AFX_SAMPLER_H__59182004_8B9B_4575_910F_A87D5F78A039__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//! A class used to sample a vectorfield 
/*! This class produces samplepoints distributed over a vectorfield
	using simple analytical equitations.
*/
class CSampler  
{
public:
	CSampler();
	virtual ~CSampler();

public:
	
	int GetAdditionalSize();
	void SetAdditionalSize(int size);
	//! sets current position value for sampler
	void SetPos(CPoint3D pos);
	//! computes Samplepoint for specified position
	virtual CSamplePoint ComputeSample() = 0;

protected:
	virtual void SetAddInfo(float *additional);
	int m_AdditionalSize;
	CPoint3D m_Pos;
	CVector3D m_Vector;
};

#endif // !defined(AFX_SAMPLER_H__59182004_8B9B_4575_910F_A87D5F78A039__INCLUDED_)
