// SinTable.cpp: implementation of the CSinTable class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "flow3d.h"
#include "SinTable.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSinTable::CSinTable(float start, float end, int width)
{
    const float pi = (float)(4.0f * atan(1.0f));

    m_SinTable = new float[width];
       
    for (int i=0; i < width; i++)
        m_SinTable[i] = (float)sin((start + (i* ((end - start) / width))) * 
						 pi/180.0f);
}

CSinTable::CSinTable()
{
	m_SinTable = NULL;
}

CSinTable::~CSinTable()
{
	if(m_SinTable != NULL)
		delete m_SinTable;
}

float CSinTable::GetSin(int index)
{
	return m_SinTable[index];
}
