// StreamlineFinder.h: interface for the CStreamlineFinder class.
//
//////////////////////////////////////////////////////////////////////
#include "StreamlineQueue.h"
#include "CandidateChooser.h"

#if !defined(AFX_STREAMLINEFINDER_H__58E5CBBA_05E2_43B5_962B_72FB7DB65EBB__INCLUDED_)
#define AFX_STREAMLINEFINDER_H__58E5CBBA_05E2_43B5_962B_72FB7DB65EBB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
//! class to find new streamlines by applying the ESS-algorithm
class CStreamlineFinder  
{
public:
	//! Adds streamlines in list into queue and updates dsepgrid.
	void AddStreamlines(CObList *streamlines);
	CStreamlineQueue * GetStreamlines();
	CStreamlineFinder(CDSepGrid *dSepGrid,CInterpolator *interpolator,
					  CIntegrator *integrator, CCandidateChooser *chooser);
	//! applies one ESS-step
	CStreamline *ApplyESS();
	//! adds one streamline derived from pos to queue
	void AddLine(CPoint3D pos);
	void Init();
	
	CStreamlineFinder();
	virtual ~CStreamlineFinder();

private:
	CDSepGrid *m_DSepGrid;
	CInterpolator *m_Interpolator;
	CIntegrator *m_Integrator;
	CCandidateChooser *m_Chooser;
	CStreamlineQueue m_Streamlines;
	
};

#endif // !defined(AFX_STREAMLINEFINDER_H__58E5CBBA_05E2_43B5_962B_72FB7DB65EBB__INCLUDED_)
