// StreamlineMaterial.h: interface for the CStreamlineMaterial class.
//
//////////////////////////////////////////////////////////////////////
#include "gl/gl.h"

#if !defined(AFX_STREAMLINEMATERIAL_H__951DFA82_1E41_4DBF_A90F_4906915B5080__INCLUDED_)
#define AFX_STREAMLINEMATERIAL_H__951DFA82_1E41_4DBF_A90F_4906915B5080__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//! Class representing material of streamlines.
class CStreamlineMaterial : public CObject
{
public:
	//! Overloaded operator '='.
	CStreamlineMaterial& operator=(const CStreamlineMaterial &material);

	CStreamlineMaterial(GLubyte *ambientRGB, GLubyte *diffuseRGB, 
						GLubyte *specularRGB, GLubyte opacity);

	//! Copy-constructor.
	CStreamlineMaterial(const CStreamlineMaterial &material);

	void GetSpecularRGB(GLubyte *specularRGB);
	void GetDiffuseRGB(GLubyte *diffuseRGB);
	void GetAmbientRGB(GLubyte *ambientRGB);

	void SetAmbientRGB(GLubyte *ambientRGB);
	void SetDiffuseRGB(GLubyte *diffuseRGB);
	void SetSpecularRGB(GLubyte *specularRGB);

	void SetOpacity(GLubyte opacity);

	GLubyte m_AmbientRGB[3];
	GLubyte m_SpecularRGB[3];
	GLubyte m_DiffuseRGB[3];

	GLfloat m_AmbRGBF[3];
	GLfloat m_DifRGBF[3];
	GLfloat m_SpecRGBF[3];

	GLubyte m_Opacity;
	float m_OpacityF;
	CStreamlineMaterial();
	virtual ~CStreamlineMaterial();

};

#endif // !defined(AFX_STREAMLINEMATERIAL_H__951DFA82_1E41_4DBF_A90F_4906915B5080__INCLUDED_)
