// StreamlinePiece.cpp: implementation of the CStreamlinePiece class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "flow3d.h"
#include "StreamlinePiece.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStreamlinePiece::CStreamlinePiece()
{
	m_StartPoint = NULL;
	m_EndPoint = NULL;
	m_Index = 0;
	m_Streamline = NULL;
	m_IsDraw = true;
	m_IsInside = true;
	m_ResIndex = 0;

	for(int i=0;i<4;i++)
		m_Color[i] = DEF_COLOR_MAX;

	m_RegIndex = 0;
}

CStreamlinePiece::~CStreamlinePiece()
{

}

CStreamlinePiece::CStreamlinePiece(CSamplePoint *startPoint, CSamplePoint *endPoint, 
								   int index, CStreamline *streamline)
{
	m_StartPoint = startPoint;
	m_EndPoint = endPoint;
	m_Index = index;
	m_Streamline = streamline;
	m_LineWidth = 0;
	m_RegIndex = 0;
	m_IsDraw = true;
	m_IsInside = true;
	m_ResIndex = 0;
	m_EndTapIndex = 0;
	m_IsLineStart = false;

	for(int i=0;i<4;i++)
		m_Color[i] = DEF_COLOR_MAX;
}

CStreamline *CStreamlinePiece::GetStreamline()
{
	return m_Streamline;
}

float CStreamlinePiece::GetStartPXPos()
{
	return m_StartPoint->GetXPos();
}

float CStreamlinePiece::GetStartPYPos()
{
	return m_StartPoint->GetYPos();
}

float CStreamlinePiece::GetStartPZPos()
{
	return m_StartPoint->GetZPos();
}

float CStreamlinePiece::CalcDifOrient()
{
	CVector3D *unit1 = m_StartPoint->GetUnitVec();
	CVector3D *unit2 = m_EndPoint->GetUnitVec();

	CVector3D gradVec(unit1->m_XComp - unit2->m_XComp,
				      unit1->m_YComp - unit2->m_YComp,
				      unit1->m_ZComp - unit2->m_ZComp);
	
	return gradVec.Magnitude();
}

float CStreamlinePiece::CalcDifVLen()
{
	return m_StartPoint->GetMagnitude() - m_EndPoint->GetMagnitude();
}
