// StreamlineQueue.h: interface for the CStreamlineQueue class.
//
//////////////////////////////////////////////////////////////////////
#include "Streamline.h"

#if !defined(AFX_STREAMLINEQUEUE_H__4F6FDE6F_5D4D_48E5_9B43_8EAA161763FD__INCLUDED_)
#define AFX_STREAMLINEQUEUE_H__4F6FDE6F_5D4D_48E5_9B43_8EAA161763FD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//! A class to store streamlines in a queue.
/*! This class is mainly used by the CStreamlineFinder-class for the
	ESS-algorithm
*/
class CStreamlineQueue  
{
public:
	//! Checks if the queue is empty.
	bool IsEmpty();
	//! Pushes one streamline on the queue.
	void Push(CStreamline *streamline);
	//! Pops one streamline from the queue.
	CStreamline * Pop();
	//! Returns list of streamlines contained in the queue.
	CObList * GetStreamlines();
	CStreamlineQueue();
	virtual ~CStreamlineQueue();

private:
	CObList m_Streamlines;
};

#endif // !defined(AFX_STREAMLINEQUEUE_H__4F6FDE6F_5D4D_48E5_9B43_8EAA161763FD__INCLUDED_)
