// TestSampler.cpp: implementation of the CTestSampler class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Flow3D.h"
#include "TestSampler.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTestSampler::CTestSampler()
{
	m_Param1 = 0.5f;
	m_Param2 = 0.5f;
	m_AdditionalSize = 0;
}

CTestSampler::CTestSampler(CPoint3D center, float param1, float param2, int additionalSize)
{
	m_Center = center;
	m_Param1 = param1;
	m_Param2 = param2;
	m_AdditionalSize = additionalSize;
}

CTestSampler::~CTestSampler()
{

}

CSamplePoint CTestSampler::ComputeSample()
{
	CSamplePoint result;
	// sort of elliptical spiral
	float xPos = m_Pos.m_XPos - m_Center.m_XPos;
	float yPos = m_Pos.m_YPos - m_Center.m_YPos;
	float zPos = m_Pos.m_ZPos - m_Center.m_ZPos;

	m_Vector.m_XComp = -yPos;
	m_Vector.m_YComp = xPos * m_Param1;
	m_Vector.m_ZComp = zPos * m_Param2;
	
	result.SetPos(m_Pos);
	result.SetVector(m_Vector);

	SetAddInfo(result.GetAdditional());
	
	return result;
}

void CTestSampler::SetCenter(CPoint3D center)
{
	m_Center = center;
}

CPoint3D CTestSampler::GetCenter()
{
	return m_Center;
}

void CTestSampler::SetParam2(float param2)
{
	m_Param2 = param2;
}

void CTestSampler::SetParam1(float param1)
{
	m_Param1 = param1;
}