// TestSampler.h: interface for the CTestSampler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESTSAMPLER_H__A27615FC_4F7D_41AE_B0D6_9DCB2BDC92EC__INCLUDED_)
#define AFX_TESTSAMPLER_H__A27615FC_4F7D_41AE_B0D6_9DCB2BDC92EC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Sampler.h"
#include "Point3D.h"	// Added by ClassView

//! Sampler-class using simple elliptical equitations.
/*! A simple class used for testing purpose, drawing elliptical spirals.*/
class CTestSampler : public CSampler  
{
public:
	//! Sets parameter responsible for form of ellipse.
	void SetParam2(float param2);
	//! Sets parameter responsible for spiral slope (0= ellipse).
	void SetParam1(float param1);
	//! Returns center of field.
	CPoint3D GetCenter();
	//! Sets center of ellipse.
	void SetCenter(CPoint3D center);
	
	CTestSampler();

	CTestSampler(CPoint3D center, float param1, float param2, int additionalSize);
	virtual ~CTestSampler();
	//! Computes samplepoint for specified position.
	virtual CSamplePoint ComputeSample();

private:
	float m_Param2;
	float m_Param1;
	CPoint3D m_Center;
};

#endif // !defined(AFX_TESTSAMPLER_H__A27615FC_4F7D_41AE_B0D6_9DCB2BDC92EC__INCLUDED_)
