// Trilinear.cpp: implementation of the CTrilinear class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Flow3D.h"
#include "Trilinear.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


CTrilinear::~CTrilinear()
{
}

CTrilinear::CTrilinear()
{
}

void CTrilinear::Interpolate(CSamplePoint *sp, CPoint3D &position,CSamplePoint ** neighbour)
{
	float factor_000 = (position.m_XPos - neighbour[B_000]->GetXPos()) * 
					   (position.m_YPos - neighbour[B_000]->GetYPos()) *
					   (position.m_ZPos - neighbour[B_000]->GetZPos());

	float factor_001 = (position.m_XPos - neighbour[B_001]->GetXPos()) * 
					   (position.m_YPos - neighbour[B_001]->GetYPos()) *
					   (neighbour[B_001]->GetZPos() - position.m_ZPos);

	float factor_010 = (position.m_XPos - neighbour[B_010]->GetXPos()) * 
					   (neighbour[B_010]->GetYPos() - position.m_YPos) *
					   (position.m_ZPos - neighbour[B_010]->GetZPos());

	float factor_011 = (position.m_XPos - neighbour[B_011]->GetXPos()) * 
					   (neighbour[B_011]->GetYPos() - position.m_YPos) *
					   (neighbour[B_011]->GetZPos() - position.m_ZPos);

	float factor_100 = (neighbour[B_100]->GetXPos() - position.m_XPos) * 
					   (position.m_YPos - neighbour[B_100]->GetYPos()) *
					   (position.m_ZPos - neighbour[B_100]->GetZPos());

	float factor_101 = (neighbour[B_101]->GetXPos() - position.m_XPos) * 
					   (position.m_YPos - neighbour[B_101]->GetYPos()) *
					   (neighbour[B_101]->GetZPos() - position.m_ZPos);

	float factor_110 = (neighbour[B_110]->GetXPos() - position.m_XPos) * 
					   (neighbour[B_110]->GetYPos() - position.m_YPos) *
					   (position.m_ZPos - neighbour[B_110]->GetZPos());
	
	float factor_111 = (neighbour[B_111]->GetXPos() - position.m_XPos) * 
					   (neighbour[B_111]->GetYPos() - position.m_YPos) *
					   (neighbour[B_111]->GetZPos() - position.m_ZPos);


	float xComp = (factor_000 * neighbour[B_111]->GetXVec() +
				   factor_001 * neighbour[B_110]->GetXVec() +
				   factor_010 * neighbour[B_101]->GetXVec() +
				   factor_011 * neighbour[B_100]->GetXVec() +
				   factor_100 * neighbour[B_011]->GetXVec() +
				   factor_101 * neighbour[B_010]->GetXVec() +
				   factor_110 * neighbour[B_001]->GetXVec() +				   
				   factor_111 * neighbour[B_000]->GetXVec());		

	float yComp = (factor_000 * neighbour[B_111]->GetYVec() +
				   factor_001 * neighbour[B_110]->GetYVec() +
				   factor_010 * neighbour[B_101]->GetYVec() +
				   factor_011 * neighbour[B_100]->GetYVec() +
				   factor_100 * neighbour[B_011]->GetYVec() +
				   factor_101 * neighbour[B_010]->GetYVec() +
				   factor_110 * neighbour[B_001]->GetYVec() +				   
				   factor_111 * neighbour[B_000]->GetYVec());	

	float zComp = (factor_000 * neighbour[B_111]->GetZVec() +
				   factor_001 * neighbour[B_110]->GetZVec() +
				   factor_010 * neighbour[B_101]->GetZVec() +
				   factor_011 * neighbour[B_100]->GetZVec() +
				   factor_100 * neighbour[B_011]->GetZVec() +
				   factor_101 * neighbour[B_010]->GetZVec() +
				   factor_110 * neighbour[B_001]->GetZVec() +				   
				   factor_111 * neighbour[B_000]->GetZVec());	

	for(int i=0;i<CSamplePoint::GetAdditionalSize();i++)
	{
		sp->SetAdditional(i,factor_000 * neighbour[B_111]->GetAdditional(i) +
							factor_001 * neighbour[B_110]->GetAdditional(i) +
							factor_010 * neighbour[B_101]->GetAdditional(i) +
							factor_011 * neighbour[B_100]->GetAdditional(i) +
							factor_100 * neighbour[B_011]->GetAdditional(i) +
							factor_101 * neighbour[B_010]->GetAdditional(i) +
							factor_110 * neighbour[B_001]->GetAdditional(i) +				   
							factor_111 * neighbour[B_000]->GetAdditional(i));	
	}
	sp->SetPos(position);
	sp->SetVector(CVector3D(xComp,yComp,zComp));
}