// Trilinear.h: interface for the CTrilinear class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRILINEAR_H__554AF695_9EEA_4195_AF67_BF9BFF066EA9__INCLUDED_)
#define AFX_TRILINEAR_H__554AF695_9EEA_4195_AF67_BF9BFF066EA9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Interpolator.h"

//! A class implementing a trilinear interpolator for cartesian grids.
/*!	This interpolator works only for cartesian grids. For rectilinear
	grids CRectTrilinear or CRectTrilinVLength should be used.
	Unlike CTrilinearVLength, the vector length is not interpolated 
	separately.
*/
class CTrilinear : public CInterpolator  
{
public:
	CTrilinear();
	virtual ~CTrilinear();
	virtual void Interpolate(CSamplePoint *sp, CPoint3D &position,CSamplePoint ** neighbour);
};

#endif // !defined(AFX_TRILINEAR_H__554AF695_9EEA_4195_AF67_BF9BFF066EA9__INCLUDED_)
