// TrilinearVLength.cpp: implementation of the CTrilinearVLength class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TrilinearVLength.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTrilinearVLength::CTrilinearVLength()
{

}

CTrilinearVLength::~CTrilinearVLength()
{

}

void CTrilinearVLength::Interpolate(CSamplePoint *sp, CPoint3D &position,CSamplePoint ** neighbour)
{
	float factor_000 = (position.m_XPos - neighbour[B_000]->GetXPos()) * 
					   (position.m_YPos - neighbour[B_000]->GetYPos()) *
					   (position.m_ZPos - neighbour[B_000]->GetZPos());

	float factor_001 = (position.m_XPos - neighbour[B_001]->GetXPos()) * 
					   (position.m_YPos - neighbour[B_001]->GetYPos()) *
					   (neighbour[B_001]->GetZPos() - position.m_ZPos);

	float factor_010 = (position.m_XPos - neighbour[B_010]->GetXPos()) * 
					   (neighbour[B_010]->GetYPos() - position.m_YPos) *
					   (position.m_ZPos - neighbour[B_010]->GetZPos());

	float factor_011 = (position.m_XPos - neighbour[B_011]->GetXPos()) * 
					   (neighbour[B_011]->GetYPos() - position.m_YPos) *
					   (neighbour[B_011]->GetZPos() - position.m_ZPos);

	float factor_100 = (neighbour[B_100]->GetXPos() - position.m_XPos) * 
					   (position.m_YPos - neighbour[B_100]->GetYPos()) *
					   (position.m_ZPos - neighbour[B_100]->GetZPos());

	float factor_101 = (neighbour[B_101]->GetXPos() - position.m_XPos) * 
					   (position.m_YPos - neighbour[B_101]->GetYPos()) *
					   (neighbour[B_101]->GetZPos() - position.m_ZPos);

	float factor_110 = (neighbour[B_110]->GetXPos() - position.m_XPos) * 
					   (neighbour[B_110]->GetYPos() - position.m_YPos) *
					   (position.m_ZPos - neighbour[B_110]->GetZPos());
	
	float factor_111 = (neighbour[B_111]->GetXPos() - position.m_XPos) * 
					   (neighbour[B_111]->GetYPos() - position.m_YPos) *
					   (neighbour[B_111]->GetZPos() - position.m_ZPos);


	float xComp = (factor_000 * neighbour[B_111]->GetUnitXVec() +
				   factor_001 * neighbour[B_110]->GetUnitXVec() +
				   factor_010 * neighbour[B_101]->GetUnitXVec() +
				   factor_011 * neighbour[B_100]->GetUnitXVec() +
				   factor_100 * neighbour[B_011]->GetUnitXVec() +
				   factor_101 * neighbour[B_010]->GetUnitXVec() +
				   factor_110 * neighbour[B_001]->GetUnitXVec() +				   
				   factor_111 * neighbour[B_000]->GetUnitXVec());		

	float yComp = (factor_000 * neighbour[B_111]->GetUnitYVec() +
				   factor_001 * neighbour[B_110]->GetUnitYVec() +
				   factor_010 * neighbour[B_101]->GetUnitYVec() +
				   factor_011 * neighbour[B_100]->GetUnitYVec() +
				   factor_100 * neighbour[B_011]->GetUnitYVec() +
				   factor_101 * neighbour[B_010]->GetUnitYVec() +
				   factor_110 * neighbour[B_001]->GetUnitYVec() +				   
				   factor_111 * neighbour[B_000]->GetUnitYVec());	

	float zComp = (factor_000 * neighbour[B_111]->GetUnitZVec() +
				   factor_001 * neighbour[B_110]->GetUnitZVec() +
				   factor_010 * neighbour[B_101]->GetUnitZVec() +
				   factor_011 * neighbour[B_100]->GetUnitZVec() +
				   factor_100 * neighbour[B_011]->GetUnitZVec() +
				   factor_101 * neighbour[B_010]->GetUnitZVec() +
				   factor_110 * neighbour[B_001]->GetUnitZVec() +				   
				   factor_111 * neighbour[B_000]->GetUnitZVec());	

	float mag = (factor_000 * neighbour[B_111]->GetMagnitude() +
				 factor_001 * neighbour[B_110]->GetMagnitude() +
				 factor_010 * neighbour[B_101]->GetMagnitude() +
				 factor_011 * neighbour[B_100]->GetMagnitude() +
				 factor_100 * neighbour[B_011]->GetMagnitude() +
				 factor_101 * neighbour[B_010]->GetMagnitude() +
				 factor_110 * neighbour[B_001]->GetMagnitude() +				   
				 factor_111 * neighbour[B_000]->GetMagnitude());	

	for(int i=0;i<CSamplePoint::GetAdditionalSize();i++)
	{
		sp->SetAdditional(i, factor_000 * neighbour[B_111]->GetAdditional(i) +
							 factor_001 * neighbour[B_110]->GetAdditional(i) +
							 factor_010 * neighbour[B_101]->GetAdditional(i) +
							 factor_011 * neighbour[B_100]->GetAdditional(i) +
							 factor_100 * neighbour[B_011]->GetAdditional(i) +
							 factor_101 * neighbour[B_010]->GetAdditional(i) +
							 factor_110 * neighbour[B_001]->GetAdditional(i) +				   
							 factor_111 * neighbour[B_000]->GetAdditional(i));	
	}

	CVector3D vec(xComp,yComp,zComp);
	vec.Normalize();

	sp->SetPos(position);
	sp->SetUnitVec(vec);
	sp->SetMagnitude(mag);
}