// TrilinearVLength.h: interface for the CTrilinearVLength class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRILINEARVLENGTH_H__62228808_AA60_49AD_91CB_9AC34D7664C3__INCLUDED_)
#define AFX_TRILINEARVLENGTH_H__62228808_AA60_49AD_91CB_9AC34D7664C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Interpolator.h"

//! A class implementing a trilinear interpolator for cartesian grids.
/*!	This interpolator works only for cartesian grids. For rectilinear
	grids CRectTrilinear or CRectTrilinearVLength should be used.
	Vector and Vector length are interpolated separately.
*/
class CTrilinearVLength : public CInterpolator  
{
public:
	CTrilinearVLength();
	virtual ~CTrilinearVLength();
	
	virtual void Interpolate(CSamplePoint *sp, CPoint3D &position,CSamplePoint ** neighbour);
};

#endif // !defined(AFX_TRILINEARVLENGTH_H__62228808_AA60_49AD_91CB_9AC34D7664C3__INCLUDED_)
